<?php
if ('yes' == get_option('wc_settings_tab_wpslash_acs_voucher_enabled')) {
	add_action('admin_menu', 'wpslash_acs_voucher_register_acs_page', 99);
}
//add acs page//

function wpslash_acs_voucher_register_acs_page() {
	foreach (wpslash_voucher_get_acs_courier_instances() as $instance_key => $instance_name) {
		add_submenu_page('woocommerce', $instance_name, $instance_name, 'manage_woocommerce', $instance_key . '-tools', 'wpslash_voucher_create_acs_page');
	}
}


function wpslash_voucher_create_acs_page() {
	$acs_instance ='acs';
	if (isset($_GET['page'])) {
		$acs_instance = str_replace('-tools', '', sanitize_text_field($_GET['page']));
	}
	wp_enqueue_style('wpslash_voucher_admin_order_css', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'css/admin.css', array(), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);
	wp_enqueue_script('wpslash_voucher_admin_order_js', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'js/admin.js', array('jquery'), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);

	wp_localize_script('wpslash_voucher_admin_order_js', 'wpslash_voucherajax', array(
	'ajaxurl' => admin_url('admin-ajax.php'),
	'ajax_nonce' => wp_create_nonce( 'wpslash_voucher_nonce' )
	));

	wp_enqueue_script('wpslash_acs_voucher_admin_order_js', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . '/js/courier.js', array('jquery'), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);

		wp_localize_script('wpslash_acs_voucher_admin_order_js', 'wpslash_acsvoucherajax', array(
		'ajaxurl' => admin_url('admin-ajax.php'),
		'ajax_nonce' => wp_create_nonce('wpslash_voucher_nonce'),
		));

	wp_enqueue_script('jquery-ui-datepicker');
	//jQuery UI theme css file
	wp_enqueue_style('e2b-admin-ui-css', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.0/themes/base/jquery-ui.css', false, '1.9.0', false);
	// Set class property ?>
  <script>
	jQuery(document).ready(function($){
	  $('input[type=text]').datepicker({
		dateFormat : "yy-mm-dd"
	  });
	});

  </script>
  <div class="wrap">
	<h2><?php esc_html_e('ACS Courier Tools', 'wpslash-acs-voucher'); ?> </h2>
	<form  id="acs_receipt_form" action="#">                            
	  <input type="hidden" value="<?php echo esc_html($acs_instance); ?>" name="acs_instance_id" id="acs_instance_id"/>  

	  <input type="text" value="<?php echo esc_html(current_time('Y-m-d')); ?>" name="acs_date" id="acs_date"/>  
	  <button class="button get_receipt_list" type="submit"><?php esc_html_e('Get Receipt List', 'wpslash-acs-voucher'); ?></button>
	</form>



	<div class="acs_result"></div>

  </div><!--#wrap -->

	<?php
}


?>
