<?php
add_action('wpslash_voucher_status_changed_to_completed_global', 'wpslash_acs_voucher_changed_to_completed', 10, 2);
function wpslash_acs_voucher_changed_to_completed( $wpslash_voucher_global_completed_courier, $order_id) {
	foreach (wpslash_voucher_get_acs_courier_instances() as $instance_key => $instance_name) {

	
		if (in_array($instance_key, $wpslash_voucher_global_completed_courier)  && wpslash_voucher_check_if_acs_can_auto_created($order_id, $instance_key) === true) {

			global $woocommerce;
			$order      = wc_get_order( $order_id );
			$order_data = $order->get_data(); // The Order data
			$order_number = $order->get_order_number();

			$order_parent_id            = $order_data['parent_id'];
			$order_status               = $order_data['status'];
			$order_currency             = $order_data['currency'];
			$order_version              = $order_data['version'];
			$order_payment_method       = $order_data['payment_method'];
			$order_payment_method_title = $order_data['payment_method_title'];
			$order_total                = $order_data['total'];

			$recipient_name    = $order_data['shipping']['first_name'] . ' ' . $order_data['shipping']['last_name'];   
			$recipient_address = $order_data['shipping']['address_1'] . ' ' . $order_data['shipping']['address_2']; 
			$recipient_area    = $order_data['shipping']['city'];  
			$recipient_postal  = $order_data['shipping']['postcode'];    
			$recipient_phone   = $order_data['billing']['phone']; 
			$recipient_notes   = $order_data['customer_note'] . ''; 
			$recipient_country = $order_data['shipping']['country']; 

			$parcel_count = get_post_meta( $order_id, 'wpslash_voucher_count', true );
			$charge       = get_post_meta( $order_id, 'wpslash_voucher_charge', true );
			$sat          = get_post_meta( $order_id, 'wpslash_voucher_sat', true );
			$rdo          = get_post_meta( $order_id, 'wpslash_voucher_rdo', true );
			$rec          = get_post_meta( $order_id, 'wpslash_voucher_rec', true );
			$default_content_type_id = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_default_parcel_type', true);
			$content_type_id = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type', true);
			$content_type_id = !empty($content_type_id) ? $content_type_id : $default_content_type_id;
			$parcel_type_description = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type_description', true);



			if (!$parcel_count) {
				$parcel_count =1;

			} 


			require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';


			$acs_company_id  =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_company_id', true );
			$acs_customer_id =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_customer_id', true );

			$acs_company_password =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_company_password', true );
			$acs_username         =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_username', true );
			$acs_password         =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_password', true );
			$acs_sender_name      =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_sender_name', true );
			$acs_api_key          =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_api_key', true );
			$reference_key_1 = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_reference_key_1', true);
			$reference_key_2 = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_reference_key_2', true);
			$acs_cyprus_economy =  ( 'yes' == get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_cyprus_economy', false) ) ? true : false ;
			if (!empty($reference_key_1)) {
				$reference_key_1 = str_replace('{order_number}', $order_number, $reference_key_1);
			}
			if (!empty($reference_key_2)) {
				$reference_key_2 = str_replace('{order_number}', $order_number, $reference_key_2);
			}



			if (!$parcel_count) {
				$parcel_count =1;
			} 

			if ($charge) {
				if (1==$charge) {
					$charge =2;
				} elseif (2==$charge) {
					$charge =4;
				}


			} else {
				$charge =2;

			}



			if (!empty($acs_company_id) && !empty($acs_company_password) && !empty($acs_username)&& !empty($acs_password) && !empty($acs_sender_name)&& !empty($acs_customer_id)) {




				$current_tracking = get_post_meta( $order_id, 'wpslash_voucher_courier_tracking', true );

				$acs_response = null;

				//if voucher is not exists...generate one
				if (empty($current_tracking)) {   


					//if old method used//    
					if (empty($acs_api_key)) {
						//check if cod is enabled// 
						if ('cod' == $order_payment_method ) {



							$acs_response =   wpslash_acs_voucher_generate_voucher($order_id, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes , true, $order_total, $parcel_count, $charge, $sat, $rdo, $rec);



						} else {


							$acs_response =    wpslash_acs_voucher_generate_voucher($order_id, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, false, 0, $parcel_count, $charge, $sat, $rdo, $rec);

						}   
						//is not cod//


						if (!empty($acs_response->no_pod)) {




							$order->update_meta_data( 'wpslash_voucher_courier', 'acs' );
							$order->update_meta_data( 'wpslash_voucher_courier_tracking', $acs_response->no_pod );
							$order->update_meta_data( 'wpslash_voucher_courier_instance_id', $instance_key );
							$order->update_meta_data( 'wpslash_voucher_courier_date', current_time('Y-m-d') );



							$order->save();

						} else {

							$acs_response->errorMsg;


						}



					} else {
						if ('cod' == $order_payment_method ) {



							$acs_response =   wpslash_acs_voucher_generate_voucher_api($order_id, $order_number, $acs_api_key, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes , true, $order_total, $parcel_count, $charge, $sat, $rdo, $rec, $reference_key_1, $reference_key_2, $content_type_id, $parcel_type_description, $acs_cyprus_economy);




						} else {


							$acs_response =    wpslash_acs_voucher_generate_voucher_api($order_id, $order_number, $acs_api_key, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, false, 0, $parcel_count, $charge, $sat, $rdo, $rec, $reference_key_1, $reference_key_2, $content_type_id, $parcel_type_description, $acs_cyprus_economy);

						}   





						if (''==$acs_response->ACSExecution_HasError->ACSValueOutput[0]->Error_Message && !$acs_response->ACSExecution_HasError) {



							$order->update_meta_data( 'wpslash_voucher_courier', 'acs' );
							$order->update_meta_data( 'wpslash_voucher_courier_tracking', $acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No );
							$order->update_meta_data( 'wpslash_voucher_courier_instance_id', $instance_key );
							$order->update_meta_data( 'wpslash_voucher_courier_date', current_time('Y-m-d') );

							$order->save();

						} else {

							if ($acs_response->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
								error_log($acs_response->ACSOutputResponce->ACSValueOutput[0]->Error_Message);
							}
							if ($acs_response->ACSExecution_HasError) {
								error_log($acs_response);


							}

						}





					}




				}//end if voucher is not generated      








			}//check if user has been completed all the required info




		} //if courier is acs//

	}//end foreach//
}


