<?php

$acs_auto_tracing_enabled = get_option('wc_settings_tab_wpslash_acs_voucher_auto_tracing_enabled', true);

if ('yes' == $acs_auto_tracing_enabled) {
	// Scheduled Action Hook
	function wpslash_acs_voucher_auto_trace() {
		global $woocommerce;

		require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';
		foreach (wpslash_voucher_get_acs_courier_instances() as $instance_key => $instance_name) {

			$acs_company_id       = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_company_id', true);
			$acs_company_password = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_company_password', true);
			$acs_username         = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_username', true);
			$acs_password         = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_password', true);
			$acs_api_key          = get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_api_key', true);

			if (!empty($acs_company_id) && !empty($acs_company_password) && !empty($acs_username) && !empty($acs_password)) {
				$args       = array(
				'status' => 'completed',

				'date_completed' => gmdate('Y-m-d', strtotime('-8 days')) . '...' . gmdate('Y-m-d', strtotime('-1 day')),
				'wpslash_voucher_courier' => 'acs',
				'wpslash_voucher_courier_instance_id' =>$instance_key,
				'return' => 'ids',
				'limit' => -1,
				);
				$orders_ids = wc_get_orders($args);

				if (empty($acs_api_key)) {
					wpslash_acs_voucher_trace_bulk($acs_company_id, $acs_company_password, $acs_username, $acs_password, $orders_ids);
				} else {
					wpslash_acs_voucher_trace_bulk_api($acs_api_key, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $orders_ids);
				}
			}//check if user has been completed all the required info
		}//end foreach//
	}
	add_action('wpslash_acs_voucher_auto_trace', 'wpslash_acs_voucher_auto_trace');

	// Schedule Cron Job Event
	function wpslash_acs_voucher_trace_auto_cron() {
		
		if (!wp_next_scheduled('wpslash_acs_voucher_auto_trace')) {
			$acs_frequency = get_option('wc_settings_tab_wpslash_acs_voucher_auto_tracing_frequency', true);

			wp_schedule_event(current_time('timestamp'), $acs_frequency, 'wpslash_acs_voucher_auto_trace');
		}
	}
	add_action('wp', 'wpslash_acs_voucher_trace_auto_cron');
}

function wpslash_acs_voucher_handle_courier_query_var( $query, $query_vars) {
	if (!empty($query_vars['wpslash_acs_voucher_courier'])) {
		$query['meta_query'][] = array(
		'key' => 'wpslash_acs_voucher_courier',
		'value' => esc_attr($query_vars['wpslash_acs_voucher_courier']),
		);
	}

	return $query;
}
add_filter('woocommerce_order_data_store_cpt_get_orders_query', 'wpslash_acs_voucher_handle_courier_query_var', 10, 2);
