<?php



if (!function_exists('wpslash_voucher_get_acs_courier_instances')) {
	function wpslash_voucher_get_acs_courier_instances() {
		$instances =  array();
	
			$instances['acs'] = esc_html__('ACS Courier', 'wpslash-acs-voucher');

			$courier_number_instances = get_option('wc_settings_tab_wpslash_voucher_global_acs_instances', true); 
		if ($courier_number_instances > 1) {
			for ($i = 2; $i <= $courier_number_instances; $i++) {
					$instances['acs_' . $i] = esc_html__('ACS Courier', 'wpslash-acs-voucher') . ' ' . $i;


			}
		}

		
		return apply_filters('wpslash_voucher_acs_courier_instances_list_array', $instances);
	}
}




add_filter('wpslash_voucher_courier_list_array', 'wpslash_voucher_add_acs_to_array');
function wpslash_voucher_add_acs_to_array( $couriers) {
	if (!array_key_exists('acs', $couriers)) {
		$couriers['acs'] = esc_html__('ACS Courier', 'wpslash-acs-voucher');
	}

	return $couriers;
}

add_filter('wpslash_voucher_courier_parcel_types', 'wpslash_voucher_add_acs_parcel_types_to_array');
function wpslash_voucher_add_acs_parcel_types_to_array( $parcel_tyoes) {
	if (!array_key_exists('acs', $parcel_tyoes)) {
		$parcel_tyoes['acs'] =  array(

				'1' => 'ΑΝΤΑΛΛΑΚΤΙΚΑ',
				'2' => 'ΒΙΒΛΙΑ',
				'3' => 'ΒΙΤΑΜΙΝΕΣ, ΠΑΡΑΦΑΡ/ΤΙΚΑ',
				'4' => 'ΕΙΔΗ ΔΙΑΚΟΣΜΗΣΗΣ',
				'5' => 'ΕΙΔΗ ΚΑΛΛΩΠΙΣΜΟΥ',
				'6' => 'ΗΛΕΚΤΡΟΝΙΚΑ',
				'7' => 'ΚΑΛΛΥΝΤΙΚΑ',
				'8' => 'ΚΙΝΗΤΟ',
				'9' => 'ΚΟΣΜΗΜΑ FEAU BIJOUX',
				'10' => 'ΞΗΡΑ ΤΡΟΦΗ',
				'11' => 'ΟΠΤΙΚΑ',
				'12' => 'ΠΑΙΧΝΙΔΙΑ',
				'13' => 'ΠΡΟΣΩΠΙΚΑ ΕΙΔΗ',
				'14' => 'ΡΟΥΧΑ',
				'15' => 'ΥΠΟΔΗΜΑΤΑ',
				'16' => 'ΦΑΡΜΑΚΑ',
				'17' => 'ΧΡΕΩΓΡΑΦΑ',
				'18' => 'ΑΛΛΑ'
	
		);
	}

	return $parcel_tyoes;
}


add_action('wpslash_voucher_shop_order_settings_after_charge', 'wpslash_add_dropdown_acs_parcel_type_dropdown_for_cyprus_orders', 10, 1);

function wpslash_add_dropdown_acs_parcel_type_dropdown_for_cyprus_orders( $order_id) {
	$order = wc_get_order($order_id);
	$shipping_country = $order->get_shipping_country();
	if ('CY' == $shipping_country) : ?>
		<?php 
		$acs_parcel_types = wpslash_voucher_get_courier_parcel_types_by_courier('acs'); 
		$default_content_type_id = get_option('wc_settings_tab_wpslash_acs_voucher_default_parcel_type', true);


		?>
		<?php 
		$wpslash_voucher_acs_parcel_type = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type', true);
		$wpslash_voucher_acs_parcel_type_description = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type_description', true);



		$wpslash_voucher_acs_parcel_type = !empty($wpslash_voucher_acs_parcel_type) ? $wpslash_voucher_acs_parcel_type : $default_content_type_id;
		$wpslash_voucher_acs_parcel_type = !empty($wpslash_voucher_acs_parcel_type) ? $wpslash_voucher_acs_parcel_type : $default_content_type_id;
		$style_element ='display:none;';
		if (18 == $wpslash_voucher_acs_parcel_type) {
				$style_element ='display:block;';
		}
		?>
				<label><?php esc_html_e('Parcel Type', 'wpslash-acs-voucher'); ?></label>

			<select class="wpslash_voucher_acs_parcel_type" order-id="<?php echo esc_html($order_id); ?>">							

		<?php foreach ($acs_parcel_types as $parcel_type_key => $parcel_type_name) : ?>
				<?php $selected = ( $wpslash_voucher_acs_parcel_type == $parcel_type_key ) ? ' selected':''; ?>
				<option value="<?php echo esc_html($parcel_type_key); ?>" <?php echo esc_html($selected); ?>><?php echo esc_html($parcel_type_name); ?></option>
								


	<?php endforeach; ?>
		</select>
		<input type="text" class="wpslash_voucher_acs_parcel_type_description" style="<?php echo esc_html($style_element); ?>" order-id="<?php echo esc_html($order_id); ?>" value="<?php echo esc_html($wpslash_voucher_acs_parcel_type_description); ?>" placeholder="πχ: Τσαντες">
	<?php endif; ?>
	<?php
}


add_action('wpslash_voucher_generate_popup_main', 'wpslash_acs_courier_generate_popup', 10);
function wpslash_acs_courier_generate_popup() {
			check_ajax_referer('wpslash_voucher_nonce', 'security');

	if (isset($_POST['courier']) && 'acs' === $_POST['courier']) {
		require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';
		$instance_id = 'acs';
		if (isset($_POST['instance_id'])) {
			$instance_id = sanitize_text_field($_POST['instance_id']);
		}

		$acs_company_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_id', true);
		$acs_customer_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_customer_id', true);

		$acs_company_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_password', true);
		$acs_username = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_username', true);
		$acs_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_password', true);
		$acs_sender_name = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_sender_name', true);
		$acs_api_key = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_api_key', true);
		$reference_key_1 = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_reference_key_1', true);
		$reference_key_2 = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_reference_key_2', true);
		$default_content_type_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_default_parcel_type', true);
		$acs_cyprus_economy =  ( 'yes' == get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_cyprus_economy', false) ) ? true : false ;


		if (!empty($acs_company_id) && !empty($acs_company_password) && !empty($acs_username) && !empty($acs_password) && !empty($acs_sender_name) && !empty($acs_customer_id) && isset($_POST['order_id'])) {
			$order_id = (int) $_POST['order_id'];
			$order = wc_get_order($order_id);
			$order_data = $order->get_data(); // The Order data
			$order_number = $order->get_order_number();


			if (!empty($reference_key_1)) {
				$reference_key_1 = str_replace('{order_number}', $order_number, $reference_key_1);
			}
			if (!empty($reference_key_2)) {
				$reference_key_2 = str_replace('{order_number}', $order_number, $reference_key_2);
			}

			$order_id = $order_data['id'];
			$order_parent_id = $order_data['parent_id'];
			$order_status = $order_data['status'];
			$order_currency = $order_data['currency'];
			$order_version = $order_data['version'];
			$order_payment_method = $order_data['payment_method'];
			$order_payment_method_title = $order_data['payment_method_title'];
			$order_total = $order_data['total'];

			$recipient_name = $order_data['shipping']['first_name'] . ' ' . $order_data['shipping']['last_name'];
			$recipient_address = $order_data['shipping']['address_1'] . ' ' . $order_data['shipping']['address_2'];
			$recipient_area = $order_data['shipping']['city'];
			$recipient_postal = $order_data['shipping']['postcode'];
			$recipient_phone = $order_data['billing']['phone'];
			$recipient_country = $order_data['shipping']['country'];
			$recipient_notes = $order_data['customer_note'] . '';
			$recipient_notes = apply_filters('wpslash_acs_courier_notes_filter', $recipient_notes, $order_id);
			$current_tracking = get_post_meta($order_id, 'wpslash_voucher_courier_tracking', true);
			$parcel_count = get_post_meta($order_id, 'wpslash_voucher_count', true);
			$charge = get_post_meta($order_id, 'wpslash_voucher_charge', true);
			$sat = get_post_meta($order_id, 'wpslash_voucher_sat', true);
			$rdo = get_post_meta($order_id, 'wpslash_voucher_rdo', true);
			$rec = get_post_meta($order_id, 'wpslash_voucher_rec', true);
			$content_type_id = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type', true);
			$parcel_type_description = get_post_meta($order_id, 'wpslash_voucher_acs_parcel_type_description', true);

			$content_type_id = !empty($content_type_id) ? $content_type_id : $default_content_type_id;
			if (!$parcel_count) {
				$parcel_count = 1;
			}

			if ($charge) {
				if (1 == $charge) {
					$charge = 2;
				} elseif (2 == $charge) {
					$charge = 4;
				}
			} else {
				$charge = 2;
			}
			$acs_response = null;

			//if voucher is not exists...generate one
			if (empty($current_tracking)) {
				//if old method used//
				if (empty($acs_api_key)) {
					//check if cod is enabled//
					if ('cod' == $order_payment_method) {
						$acs_response = wpslash_acs_voucher_generate_voucher($order_id, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, true, $order_total, $parcel_count, $charge, $sat, $rdo, $rec);
					} else {
						$acs_response = wpslash_acs_voucher_generate_voucher($order_id, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, false, 0, $parcel_count, $charge, $sat, $rdo, $rec);
					}
					//is not cod//

					if (!empty($acs_response->no_pod)) {
						$content ='';
						$content .=  esc_html__('Voucher is Generated:', 'wpslash-acs-voucher') . ' ' . esc_html($acs_response->no_pod);

						$content .=  '<div class="actions">';
						$content .=  '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->no_pod) . '" paper="2">' . esc_html__('Print Voucher A4', 'wpslash-acs-voucher') . '</a>';
						$content .=  '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->no_pod) . '" paper="1">' . esc_html__('Print Voucher Thermal', '    wpslash-acs-voucher') . '</a>';

						$content .=  '<a class="button wpslash_voucher_courier_cancel" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->no_pod) . '" order_id="' . esc_html($order_id) . '">' . esc_html__('Cancel Voucher', 'wpslash-acs-voucher') . '</a>';
						$content .=  '<a class="button wpslash_voucher_courier_trace" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->no_pod) . '" >' . esc_html__('Trace Voucher', 'wpslash-acs-voucher') . '</a>';

						$content .=  '</div>';

					  
						$order->update_meta_data('wpslash_voucher_courier_instance_id', $instance_id);
						$order->update_meta_data('wpslash_voucher_courier', 'acs');
						$order->update_meta_data('wpslash_voucher_courier_tracking', sanitize_text_field($acs_response->no_pod));
						$order->update_meta_data('wpslash_voucher_courier_date', current_time('Y-m-d'));

						$order->save();
						$tracking = esc_html($acs_response->no_pod);
						$courier_list = wpslash_voucher_get_all_courier_instances();
						$courier  = $courier_list[$instance_id];

						$response_array =  array('content'=>$content, 'courier'=>$courier, 'tracking'=>$tracking);

						echo json_encode($response_array);
					} else {
						$content = '';
						$content .= esc_html__('Something gone wrong', 'wpslash-acs-voucher') . '<br/>';
						$content .= esc_html($acs_response->errorMsg);

						$response_array =  array('content'=>$content);

						echo json_encode($response_array);
					}
				} else {
					if ('cod' == $order_payment_method) {
						$acs_response = wpslash_acs_voucher_generate_voucher_api($order_id, $order_number, $acs_api_key, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, true, $order_total, $parcel_count, $charge, $sat, $rdo, $rec, $reference_key_1, $reference_key_2, $content_type_id, $parcel_type_description, $acs_cyprus_economy);
					} else {
						$acs_response = wpslash_acs_voucher_generate_voucher_api($order_id, $order_number, $acs_api_key, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, false, 0, $parcel_count, $charge, $sat, $rdo, $rec, $reference_key_1, $reference_key_2, $content_type_id, $parcel_type_description, $acs_cyprus_economy);
					}

					if ('' == $acs_response->ACSOutputResponce->ACSValueOutput[0]->Error_Message && !$acs_response->ACSExecution_HasError) {

						$content = '';
						$content .=  esc_html__('Voucher is Generated:', 'wpslash-acs-voucher') . ' ' . esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No);

						 $content .= '<div class="actions">';
						 $content .= '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No) . '" paper="2">' . esc_html__('Print Voucher A4', 'wpslash-acs-voucher') . '</a>';
						 $content .= '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No) . '" paper="1">' . esc_html__('Print Voucher Thermal', '    wpslash-acs-voucher') . '</a>';

						 $content .= '<a class="button wpslash_voucher_courier_cancel" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No) . '" order_id="' . esc_html($order_id) . '">' . esc_html__('Cancel Voucher', 'wpslash-acs-voucher') . '</a>';
						 $content .= '<a class="button wpslash_voucher_courier_trace" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No) . '" >' . esc_html__('Trace Voucher', 'wpslash-acs-voucher') . '</a>';

						 $content .= '</div>';
						$order->update_meta_data('wpslash_voucher_courier_instance_id', $instance_id);
						$order->update_meta_data('wpslash_voucher_courier', 'acs');
						$order->update_meta_data('wpslash_voucher_courier_tracking', sanitize_text_field($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No));
						$order->update_meta_data('wpslash_voucher_courier_date', current_time('Y-m-d'));

						$order->save();

						$tracking = esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Voucher_No);
						$courier_list = wpslash_voucher_get_all_courier_instances();
						$courier  = $courier_list[$instance_id];

						 $response_array =  array('content'=>$content, 'courier'=>$courier, 'tracking'=>$tracking);

						echo json_encode($response_array);

					} else {
						$content='';
						  $content .= esc_html__('Something gone wrong', 'wpslash-acs-voucher') . '<br/>';
						if ($acs_response->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
							  $content .= esc_html($acs_response->ACSOutputResponce->ACSValueOutput[0]->Error_Message);
						}
						if ($acs_response->ACSExecution_HasError) {
							  $content .= esc_html($acs_response->ACSExecutionErrorMessage);
						}

						$response_array =  array('content'=>$content);

						echo json_encode($response_array);
					}
				}

				//else use the new method//

				//if old method used//

				//if the voucher is ok//

				//else if end demo codes and cod//
			} else {
				$content ='';
				$content .=  esc_html__('Voucher is Already Exists:', 'wpslash-acs-voucher') . ' ' . esc_html($current_tracking);

				$content .= '<div class="actions">';
				$content .= '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($current_tracking) . '" paper="2">' . esc_html__('Print Voucher A4', 'wpslash-acs-voucher') . '</a>';
				$content .= '<a class="button wpslash_voucher_courier_print" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($current_tracking) . '" paper="1">' . esc_html__('Print Voucher Thermal', ' wpslash-acs-voucher') . '</a>';
				$content .= '<a class="button wpslash_voucher_courier_cancel" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($current_tracking) . '" order_id="' . esc_html($order_id) . '">' . esc_html__('Cancel Voucher', 'wpslash-acs-voucher') . '</a>';
				$content .= '<a class="button wpslash_voucher_courier_trace" courier="acs" instance-id="' . esc_html($instance_id) . '" tracking="' . esc_html($current_tracking) . '" order_id="' . esc_html($order_id) . '">' . esc_html__('Trace Voucher', 'wpslash-acs-voucher') . '</a>';

				$content .= '</div>';


						  $tracking = esc_html($current_tracking);
						$courier_list = wpslash_voucher_get_all_courier_instances();
						$courier  = $courier_list[$instance_id];

						 $response_array =  array('content'=>$content, 'courier'=>$courier, 'tracking'=>$tracking);

						echo json_encode($response_array);
			}
		} else {

			$content = esc_html__('Check your ACS configuration.', 'wpslash-acs-voucher');

			$response_array =  array('content'=>$content);

						echo json_encode($response_array);

		}
	}
}

add_action('wpslash_voucher_print_pdf_main', 'wpslash_acs_courier_print_pdf', 10);
function wpslash_acs_courier_print_pdf() {
			check_ajax_referer('wpslash_voucher_nonce', 'security');

	if (isset($_POST['courier']) && 'acs' === $_POST['courier']) {
		require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';
		$instance_id = 'acs';
		if (isset($_POST['instance_id'])) {
			$instance_id = sanitize_text_field($_POST['instance_id']);
		}

		$acs_company_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_id', true);
		$acs_company_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_password', true);
		$acs_username = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_username', true);
		$acs_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_password', true);

		if (!empty($acs_company_id) && !empty($acs_company_password) && !empty($acs_username) && !empty($acs_password) && isset($_POST['tracking']) && isset($_POST['paper'])) {
			$tracking = sanitize_text_field($_POST['tracking']);
			$paper = sanitize_text_field($_POST['paper']);
			$acs_response = null;

			wpslash_acs_voucher_print_voucher_pdf($acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $paper);
		} else {
			esc_html_e('Check your ACS configuration.', 'wpslash-acs-voucher');
		}
	}
}

add_action('wpslash_voucher_cancel_main', 'wpslash_acs_courier_cancel', 10);
function wpslash_acs_courier_cancel() {
				check_ajax_referer('wpslash_voucher_nonce', 'security');

	if (isset($_POST['courier']) && 'acs' === $_POST['courier'] && isset($_POST['tracking']) && isset($_POST['order_id'])) {
		require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';
		$instance_id = 'acs';
		if (isset($_POST['instance_id'])) {
			$instance_id = sanitize_text_field($_POST['instance_id']);
		}

		$acs_company_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_id', true);
		$acs_company_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_password', true);
		$acs_username = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_username', true);
		$acs_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_password', true);
		$acs_api_key = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_api_key', true);

		$tracking = sanitize_text_field($_POST['tracking']);
		$order_id = sanitize_text_field($_POST['order_id']);

		if (empty($acs_api_key)) {
			wpslash_acs_voucher_cancel_voucher($acs_company_id, $acs_company_password, $acs_username, $acs_password, $order_id, $tracking);
		} else {
			wpslash_acs_voucher_cancel_voucher_api($acs_api_key, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $order_id, $tracking);
		}
	}
}

add_action('wpslash_voucher_trace_main', 'wpslash_acs_courier_trace', 10);
function wpslash_acs_courier_trace() {
					check_ajax_referer('wpslash_voucher_nonce', 'security');

	if (isset($_POST['courier']) && 'acs' === $_POST['courier'] && isset($_POST['tracking']) && isset($_POST['order_id'])) {
		require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/functions/acs_functions.php';
		$instance_id = 'acs';
		if (isset($_POST['instance_id'])) {
			$instance_id = sanitize_text_field($_POST['instance_id']);
		}

		$tracking = sanitize_text_field($_POST['tracking']);
		$order_id = sanitize_text_field($_POST['order_id']);

		$acs_company_id = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_id', true);
		$acs_company_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_company_password', true);
		$acs_username = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_username', true);
		$acs_password = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_password', true);
		$acs_api_key = get_option('wc_settings_tab_wpslash_' . $instance_id . '_voucher_api_key', true);

		if (!empty($acs_company_id) && !empty($acs_company_password) && !empty($acs_username) && !empty($acs_password)) {
			if (empty($acs_api_key)) {
				wpslash_acs_voucher_trace($acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $order_id);
			} else {
				wpslash_acs_voucher_trace_api($acs_api_key, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $order_id);
			}
		} else {
			esc_html_e('Check your ACS configuration.', 'wpslash-acs-voucher');
		}
	}
}

add_action('wpslash_voucher_shop_order_settings_after_charge', 'wpslash_acs_add_shop_order_rdo_change', 10, 1 );
function wpslash_acs_add_shop_order_rdo_change( $order_id) {
	$acs_rdo = get_option('wc_settings_tab_wpslash_acs_voucher_rdo', true);


	$wpslash_voucher_rdo = get_post_meta($order_id, 'wpslash_voucher_rdo', true);
	
	?>
	<?php if ('yes' === $acs_rdo) : ?>
	<label><?php esc_html_e('RDO(Return Docs)', 'wpslash-geniki-voucher'); ?></label>
		<?php if (1 == $wpslash_voucher_rdo) : ?>
	<input type="checkbox" class="wpslash_voucher_rdo" value="1" order-id="<?php echo esc_html($order_id); ?>" checked/>
	<?php else : ?>
	<input type="checkbox" class="wpslash_voucher_rdo" value="0" order-id="<?php echo esc_html($order_id); ?>"/>
	<?php endif; ?>




	<?php endif; ?>
	<?php
}



add_action('wpslash_voucher_shop_order_settings_after_charge', 'wpslash_acs_add_shop_order_rec_change', 11, 1 );
function wpslash_acs_add_shop_order_rec_change( $order_id) {



	$acs_rec = get_option('wc_settings_tab_wpslash_acs_voucher_rec', true);


	$wpslash_voucher_rec = get_post_meta($order_id, 'wpslash_voucher_rec', true);
	
	?>
	<?php if ('yes' === $acs_rec) : ?>
	<label><?php esc_html_e('Reception Delivery', 'wpslash-acs-voucher'); ?></label>
		<?php if (1 == $wpslash_voucher_rec) : ?>
	<input type="checkbox" class="wpslash_voucher_rec" value="1" order-id="<?php echo esc_html($order_id); ?>" checked/>
	<?php else : ?>
	<input type="checkbox" class="wpslash_voucher_rec" value="0" order-id="<?php echo esc_html($order_id); ?>"/>
	<?php endif; ?>




	<?php endif; ?>
	<?php

	 
}





function wpslash_voucher_shoporder_acs_admin_css( $hook) {
	// $hook is string value given add_menu_page function.

	global $typenow;

	if ('shop_order' === $typenow) {
		wp_enqueue_script('wpslash_acs_voucher_admin_order_js', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . '/js/courier.js', array('jquery'), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);

		wp_localize_script('wpslash_acs_voucher_admin_order_js', 'wpslash_acsvoucherajax', array(
		'ajaxurl' => admin_url('admin-ajax.php'),
		'ajax_nonce' => wp_create_nonce('wpslash_voucher_nonce'),
		));
	}
}
add_action('admin_enqueue_scripts', 'wpslash_voucher_shoporder_acs_admin_css');

function wpslash_acs_voucher_wc_settings_selectjs( $hook) {
		// $hook is string value given add_menu_page function.

		global $typenow;

	if ('woocommerce_page_wc-settings' === $hook && isset($_GET['tab']) && ( 'wpslash_voucher' === $_GET['tab'] )) {
		wp_register_script( 'wpslash-voucher-acs-wc-settings', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'js/admin.acs.wc-settings.js', array( 'jquery', 'wpslash-voucher-select2' ), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION, true );
		wp_enqueue_script( 'wpslash-voucher-acs-wc-settings' );
	}
}
	add_action('admin_enqueue_scripts', 'wpslash_acs_voucher_wc_settings_selectjs');



function wpslash_voucher_check_if_acs_can_auto_created( $order_id, $instance_key) {
	$wpslash_acs_voucher_shipping_methods_enabled =  get_option( 'wc_settings_tab_wpslash_' . $instance_key . '_voucher_shipping_methods_enabled' );
	$wpslash_acs_voucher_shipping_countries_enabled =  get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_shipping_countries_enabled');
	$results = array();
	if (!empty($wpslash_acs_voucher_shipping_methods_enabled)) {		
				global $woocommerce;
				$order = wc_get_order($order_id);
				$order_methods = array();
		foreach ( $order->get_shipping_methods() as $shipping_method ) {
			$order_methods[] = $shipping_method->get_instance_id();
				
		
		}
	
		if ( !in_array($order_methods[0], $wpslash_acs_voucher_shipping_methods_enabled )) {
			$results['shipping_methods'] =  false;
		} else {
				$results['shipping_methods'] =  true;
		}


	


	} else {



				$results['shipping_methods'] =  true;

	}
	if (!empty($wpslash_acs_voucher_shipping_countries_enabled)) {
				global $woocommerce;
				$order = wc_get_order($order_id);
				$shipping_country = $order->get_shipping_country();
		if (!$shipping_country) {
			$shipping_country = $order->get_billing_country();
				
		}
		if (!in_array($shipping_country, $wpslash_acs_voucher_shipping_countries_enabled )) {
			$results['shipping_countries'] =  false;
		} else {
				$results['shipping_countries'] =  true;
		}

	} else {
						$results['shipping_countries'] =  true;

	}

	if (true === $results['shipping_methods'] && true === $results['shipping_countries']  ) {
		return true;
	} else {
			return false;
	
	}


}
