<?php

function wpslash_acs_voucher_email_tracking_code( $order_id) {
	$current_tracking      = get_post_meta($order_id, 'wpslash_voucher_courier_tracking', true);
	$current_courier       = get_post_meta($order_id, 'wpslash_voucher_courier', true);
	$order                 = wc_get_order($order_id);
	$acs_instance_id     = get_post_meta($order_id, 'wpslash_voucher_courier_instance_id', true);
	if (!$acs_instance_id) {
		$acs_instance_id = 'acs';
	}
	$acs_email_enabled     = get_option('wc_settings_tab_wpslash_' . $acs_instance_id . '_voucher_email_enabled', true);


	if ('acs' === $current_courier && '' != $current_tracking && 'yes' === $acs_email_enabled) {
		$order      = wc_get_order($order_id);
		$order_data = $order->get_data(); // The Order data
		$first_name = $order_data['shipping']['first_name'];
		$last_name  = $order_data['shipping']['last_name'];
		$recipient  = $order_data['billing']['email'];

		$subject = get_option('wc_settings_tab_wpslash_' . $acs_instance_id . '_voucher_email_subject', true);

		$mailer = WC()->mailer();

		$subject = str_replace('{order_id}', $order_id, $subject);

		$content = get_option('wc_settings_tab_wpslash_' . $acs_instance_id . '_voucher_email_message', true);
		$content = str_replace('{tracking_code}', $current_tracking, $content);
		$content = str_replace('{order_id}', $order_id, $content);
		$content = str_replace('{first_name}', $first_name, $content);
		$content = str_replace('{last_name}', $last_name, $content);

		$headers = "Content-Type: text/html\r\n";

		ob_start();
		wc_get_template('emails/email-header.php', array('email_heading' => $subject));
		echo wp_kses_post($content);
		wc_get_template('emails/email-footer.php');
		$message = ob_get_clean();

		$mailer->send($recipient, $subject, $message, $headers);
	}//end check if speedex courier is not empty
}

add_action('woocommerce_order_status_completed', 'wpslash_acs_voucher_email_tracking_code', 99, 1);
