<?php

function wpslash_acs_voucher_generate_voucher( $order_id, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, $cod = false, $cod_amount = 0, $parcel_count = 1, $charge = 2, $sat = 0, $rdo = 0, $rec = 0) {
	$cod_descr = '';

	$response                 = null;
	$companyId                = $acs_company_id;
	$companyPass              = $acs_company_password;
	$username                 = $acs_username;
	$password                 = $acs_password;
	$diakDateParal            = current_time('Y-m-d');
	$diakApostoleas           = $acs_sender_name;
	$diakParalhpthsOnoma      = $recipient_name;
	$diakParalhpthsDieth      = $recipient_address;
	$acDiakParalhpthsDiethAr  = ' ';
	$acDiakParalhpthsDiethPer = $recipient_area;
	$diakParalhpthsThlef      = $recipient_phone;
	$diakParalhpthsTk         = $recipient_postal;
	$stationIdDest            = null;
	$branchIdDest             = 0;
	$diakTemaxia              = $parcel_count;
	$diakVaros                = floatval(wpslash_voucher_get_order_weight($order_id));
	$diakXrewsh               = $charge;
	$diakWraMexri             = null;
	$diakAntikatPoso          = $cod_amount;
	$diakTroposPlAntikat      = '';
	$hostName                 = null;
	$diakNotes                = $recipient_notes;
	$diakCountry              = $recipient_country;
	$diakcFiller              = null;
	$acDiakStoixs             = array();
	$customerId               = $acs_customer_id;
	$diakParalhpthsCell       = '';
	$diakParalhpthsOrofos     = '';
	$diakParalhpthsCompany    = '';
	$withReturn               = 0;
	$diakcCompCus             = null;
	$specialDir               = null;

	if ($cod_amount > 0) {
		$diakTroposPlAntikat = 'Μ';
		$acDiakStoixs[]      = 'ΑΝ';
	}
	if (1 == $sat) {
		$acDiakStoixs[] = '5Σ';
	}
	if (1 == $rdo) {
		$acDiakStoixs[] = 'ΔΔ';
	}

	if (1 == $rec) {
		$acDiakStoixs[] = 'ΡΣ';
	}
	if ('CY' == $recipient_country) {

			$acDiakStoixs[] = 'EC';
	}

	if (!empty($acDiakStoixs)) {
		$acDiakStoixs = implode(',', $acDiakStoixs);
	} elseif (empty($acDiakStoixs)) {
		$acDiakStoixs = null;
	}
	try {
		$client = new SoapClient('https://services.acscourier.net/ACSCreateVoucher-portlet/axis/Plugin_ACSCreateVoucher_ACSVoucherService?wsdl');
		$result = $client->createVoucher($companyId, $companyPass, $username, $password, $diakDateParal, $diakApostoleas, $diakParalhpthsOnoma, $diakParalhpthsDieth, $acDiakParalhpthsDiethAr, $acDiakParalhpthsDiethPer, $diakParalhpthsThlef, $diakParalhpthsTk, $stationIdDest, $branchIdDest, $diakTemaxia, $diakVaros, $diakXrewsh, $diakWraMexri, $diakAntikatPoso, $diakTroposPlAntikat, $hostName, $diakNotes, $diakCountry, $diakcFiller, $acDiakStoixs, $customerId, $diakParalhpthsCell, $diakParalhpthsOrofos, $diakParalhpthsCompany, $withReturn, $diakcCompCus, $specialDir
					  );
	} catch (Exception $e) {
		// your loging regarding this case
		$response = $e;
	}

	//$response_arr = objectToArray($result);

	if ($result) {
		$response = $result;
	}//end if

	return $response;
}//end acs_generate voucher

function wpslash_acs_voucher_generate_voucher_api( $order_id, $order_number, $apikey, $acs_company_id, $acs_customer_id, $acs_company_password, $acs_username, $acs_password, $acs_sender_name, $recipient_name, $recipient_address, $recipient_postal, $recipient_area, $recipient_country, $recipient_phone, $recipient_notes, $cod = false, $cod_amount = 0, $parcel_count = 1, $charge = 2, $sat = 0, $rdo = 0, $rec = 0, $reference_key_1 = null, $reference_key_2 = null, $content_type_id = null, $content_type_description = null, $cyprus_economy = false) {
	$cod_descr             = '';
	$acs_delivery_products = array();
	$result                = null;
	$response              = null;

	if ($cod_amount > 0) {
		$acs_delivery_products[] = 'COD';
	}
	if (1 == $sat) {
		$acs_delivery_products[] = 'SAT';
	}

	if (1 == $rdo) {
		$acs_delivery_products[] = 'RDO';
	}
	if (1 == $rec) {
		$acs_delivery_products[] = 'REC';
	}
	if ('CY' == $recipient_country && $cyprus_economy) {

		$acs_delivery_products[] = 'CEC';

	}
	if (!empty($acs_delivery_products)) {
		$acs_delivery_products = implode(',', $acs_delivery_products);
	} elseif (empty($acs_delivery_products)) {
		$acs_delivery_products = null;
	}

	

	$acs_data                       = array();
	$acs_data['ACSAlias']           = 'ACS_Create_Voucher';
	$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
	'Company_Password' => $acs_company_password,
	'User_ID' => $acs_username,
	'User_Password' => $acs_password,
	'Pickup_Date' => current_time('Y-m-d'),
	'Sender' => $acs_sender_name,
	'Recipient_Name' => $recipient_name,
	'Recipient_Address' => $recipient_address,
	'Recipient_Address_Number' => ' ',
	'Recipient_Zipcode' => $recipient_postal,
	'Recipient_Region' => $recipient_area,
	'Recipient_Phone' => $recipient_phone,
	'Recipient_Cell_Phone' => $recipient_phone,
	'Recipient_Floor' => null,
	'Recipient_Company_Name' => null,
	'Recipient_Country' => $recipient_country,
	'Acs_Station_Destination' => null,
	'Acs_Station_Branch_Destination' => '1',
	'Billing_Code' => $acs_customer_id,
	'Charge_Type' => $charge,
	'Cost_Center_Code' => null,
	'Item_Quantity' => $parcel_count,
	'Weight' => floatval(wpslash_voucher_get_order_weight($order_id)),
	'Dimension_X_In_Cm' => null,
	'Dimension_Y_in_Cm' => null,
	'Dimension_Z_in_Cm' => null,
	'Cod_Ammount' => str_replace('.', ',', $cod_amount),
	'Cod_Payment_Way' => '0',
	'Acs_Delivery_Products' => $acs_delivery_products,
	'Insurance_Amount' => null,
	'Delivery_Notes' => $recipient_notes,
	'Appointment_Until_Time' => null,
	'Recipient_Email' => null,
	'Reference_Key1' => $reference_key_1,
	'Reference_Key2' => $reference_key_2,
	'With_Return_Voucher' => null,
	'Language' => null );
	if (!$content_type_id) {
		$content_type_id = '18';
	}
	
	if ('CY' == $recipient_country) {
		$acs_data['ACSInputParameters']['Content_Type_ID'] = $content_type_id;
		if (18 == $content_type_id) {
				$acs_data['ACSInputParameters']['Delivery_Notes'] = $content_type_description . ' ' . $acs_data['ACSInputParameters']['Delivery_Notes']; 
	
		}

	}


	//return var_dump(json_encode($acs_data,JSON_FORCE_OBJECT));

	$curl = curl_init();
	curl_setopt_array($curl, array(
	CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => '',
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => 'POST',
	CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
	CURLOPT_HTTPHEADER => array(
	'Access-Control-Request-Headers: *',
	'AcsApiKey: ' . $apikey . ' ',
	'Cache-Control: no-cache',
	'Content-Type: application/json',  ),
	));

	$response = curl_exec($curl);
	$err      = curl_error($curl);

	curl_close($curl);

	if ($err) {
		return 'cURL Error #:' . $err;
	} else {
		return json_decode($response);
	}
}//end acs_generate voucher

function wpslash_acs_voucher_print_voucher_pdf( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $paper = '2') {
	$pdf_data = wpslash_acs_voucher_get_contents('https://acs-eud2.acscourier.net/Eshops/GetVoucher.aspx?MainID=' . $acs_company_id . '&MainPass=' . $acs_company_password . '&UserID=' . $acs_username . '&UserPass=' . $acs_password . '&voucherno=' . $tracking . '&PrintType=' . $paper . '&StartFromNumber=1');

	echo esc_html(base64_encode($pdf_data));
}

function wpslash_acs_voucher_cancel_voucher( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $order_id, $tracking) {
	try {
		$client = new SoapClient('https://services.acscourier.net/ACSDeleteVoucher-portlet/axis/Plugin_DeleteVoucher_ACSDeleteVoucherService?wsdl');
		$result = $client->deleteACSDeleteVoucher($acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking);
	} catch (Exception $e) {
		// your loging regarding this case
		print_r($e);
	}

	if ('' == $result->error) {
		if (delete_post_meta($order_id, 'wpslash_voucher_courier') && delete_post_meta($order_id, 'wpslash_voucher_courier_tracking')) {
			echo esc_html__('Voucher Canceled', 'wpslash-acs-voucher');
		}
	} else {
		echo esc_html($result->error);
	}
}//end function

function wpslash_acs_voucher_cancel_voucher_api( $apikey, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $order_id, $tracking) {
	$acs_data                       = array();
	$acs_data['ACSAlias']           = 'ACS_Delete_Voucher';
	$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
	'Company_Password' => $acs_company_password,
	'User_ID' => $acs_username,
	'User_Password' => $acs_password,
	'Language' => null,
	'Voucher_No' => $tracking, );

	//return var_dump(json_encode($acs_data,JSON_FORCE_OBJECT));

	$curl = curl_init();
	curl_setopt_array($curl, array(
	CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => '',
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => 'POST',
	CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
	CURLOPT_HTTPHEADER => array(
	'Access-Control-Request-Headers: *',
	'AcsApiKey: ' . $apikey . ' ',
	'Cache-Control: no-cache',
	'Content-Type: application/json',  ),
	));

	$response = curl_exec($curl);
	$err      = curl_error($curl);

	curl_close($curl);

	if ($err) {
		return 'cURL Error #:' . $err;
	} else {
		$result = json_decode($response);

		if (false == $result->ACSExecution_HasError) {
			if (delete_post_meta($order_id, 'wpslash_voucher_courier') && delete_post_meta($order_id, 'wpslash_voucher_courier_tracking')) {
				delete_post_meta($order_id, 'wpslash_voucher_courier_instance_id'); 
				delete_post_meta($order_id, 'wpslash_voucher_courier_date'); 

				
				echo esc_html__('Voucher Canceled', 'wpslash-acs-voucher');
			}
		} else {
			echo esc_html($result->ACSExecutionErrorMessage);
		}
	}
}//end function

function wpslash_acs_voucher_trace( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $order_id) {
	global $woocommerce;
	try {
		$client = new SoapClient('https://services.acscourier.net/ACSTracking-portlet/axis/Plugin_acsTracking_TrackingDetailsService?wsdl');
		$result = $client->findByPod_no($acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking);
	} catch (Exception $e) {
		// your loging regarding this case
		print_r($e);
	}

	if ($result) {
		/*  echo "<pre>";
		print_r($result);
		echo "</pre>";*/

		echo '<h3>' . esc_html__('ACS Courier Tracking:') . ' ' . esc_html($tracking) . '</h3>';

		if (!empty($result[0]->check_point)) {
			echo '<table>';

			echo '<tr>';
			echo '<th>' . esc_html__('Date', 'wpslash-acs-voucher') . '</td>';

			echo '<th>' . esc_html__('Place', 'wpslash-acs-voucher') . '</td>';
			echo '<th>' . esc_html__('Tracking Number', 'wpslash-acs-voucher') . '</td>';
			echo '<th>' . esc_html__('Notes', 'wpslash-acs-voucher') . '</td>';

			echo '</tr>';

			foreach ($result as $current_status) {
				if (!empty($current_status->check_point)) {
					echo '<tr>';
					echo '<td>' . esc_html($current_status->date_time) . '</td>';
					echo '<td>' . esc_html($current_status->check_point) . '</td>';
					echo '<td>' . esc_html($tracking) . '</td>';
					echo '<td>' . esc_html($current_status->description) . '(' . esc_html($current_status->remarks) . ')</td>';

					echo '</tr>';

					if ('ΠΑΡΑΔΟΣΗ' == $current_status->description) {
						$order = wc_get_order($order_id);

						if ('deliverycompleted' != $order->get_status()) {
							$order->update_status('deliverycompleted');
						}
					} elseif ('ΕΠΙΣΤΡΟΦΗ' == $current_status->description) {
						$order = wc_get_order($order_id);

						if ('deliverydenied' != $order->get_status()) {
							$order->update_status('deliverydenied');
						}
					}
				}//if not empty
			}//end foreach

					  echo '</table>';
		}//END IF
	}
}//end acs trace voucher

function wpslash_acs_voucher_trace_api( $apikey, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $tracking, $order_id) {
	global $woocommerce;

	$acs_data                       = array();
	$acs_data['ACSAlias']           = 'ACS_TrackingDetails';
	$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
	'Company_Password' => $acs_company_password,
	'User_ID' => $acs_username,
	'User_Password' => $acs_password,
	'Language' => null,
	'Voucher_No' => $tracking, );

	$curl = curl_init();
	curl_setopt_array($curl, array(
	CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => '',
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => 'POST',
	CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
	CURLOPT_HTTPHEADER => array(
	'Access-Control-Request-Headers: *',
	'AcsApiKey: ' . $apikey . ' ',
	'Cache-Control: no-cache',
	'Content-Type: application/json',  ),
	));

	$response = curl_exec($curl);
	$err      = curl_error($curl);

	curl_close($curl);

	if ($err) {
		return 'cURL Error #:' . $err;
	} else {
		$result = json_decode($response);

		if ('' == $result->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
			echo '<h3>' . esc_html__('ACS Courier Tracking:') . ' ' . esc_html($tracking) . '</h3>';

			if (!empty($result->ACSOutputResponce->ACSTableOutput->Table_Data)) {
				echo '<table>';

				echo '<tr>';
				echo '<th>' . esc_html__('Date', 'wpslash-acs-voucher') . '</td>';

				echo '<th>' . esc_html__('Place', 'wpslash-acs-voucher') . '</td>';
				echo '<th>' . esc_html__('Tracking Number', 'wpslash-acs-voucher') . '</td>';
				echo '<th>' . esc_html__('Notes', 'wpslash-acs-voucher') . '</td>';

				echo '</tr>';

				foreach ($result->ACSOutputResponce->ACSTableOutput->Table_Data as $current_status) {
					if (!empty($current_status->checkpoint_location)) {
						echo '<tr>';
						echo '<td>' . esc_html($current_status->checkpoint_date_time) . '</td>';
						echo '<td>' . esc_html($current_status->checkpoint_location) . '</td>';
						echo '<td>' . esc_html($tracking) . '</td>';
						echo '<td>' . esc_html($current_status->checkpoint_action) . '(' . esc_html($current_status->checkpoint_notes) . ')</td>';

						echo '</tr>';

						if ('ΠΑΡΑΔΟΣΗ' == $current_status->checkpoint_action) {
							$order = wc_get_order($order_id);

							if ('deliverycompleted' != $order->get_status()) {
								$order->update_status('deliverycompleted');
							}
						} elseif ('ΕΠΙΣΤΡΟΦΗ' == $current_status->checkpoint_action) {
							$order = wc_get_order($order_id);

							if ('deliverydenied' != $order->get_status()) {
								$order->update_status('deliverydenied');
							}
						}
					}//if not empty
				}//end foreach

				echo '</table>';
			}//END IF
		} else {
			echo esc_html($result->ACSOutputResponce->ACSValueOutput[0]->Error_Message);
		}

		/*  echo "<pre>";
		print_r($result);
		echo "</pre>";*/
	}
}//end acs trace voucher

function wpslash_acs_voucher_trace_bulk( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $orders_ids) {
	global $woocommerce;
	foreach ($orders_ids as $current_order_id) {
		$current_tracking = get_post_meta($current_order_id, 'wpslash_voucher_courier_tracking', true);
		$current_courier  = get_post_meta($current_order_id, 'wpslash_voucher_courier', true);
		try {
			$client = new SoapClient('https://services.acscourier.net/ACSTracking-portlet/axis/Plugin_acsTracking_TrackingDetailsService?wsdl');
			$result = $client->findByPod_no($acs_company_id, $acs_company_password, $acs_username, $acs_password, $current_tracking);
		} catch (Exception $e) {
			// your loging regarding this case
			print_r($e);
		}

		if ($result) {
			/*  echo "<pre>";
			print_r($result);
			  echo "</pre>";*/

			if (!empty($result[0]->check_point)) {
				foreach ($result as $current_status) {
					if (!empty($current_status->check_point)) {
						if ('ΠΑΡΑΔΟΣΗ' == $current_status->description) {
							$order = wc_get_order($current_order_id);

							if ('deliverycompleted' != $order->get_status()) {
								$order->update_status('deliverycompleted');
							}
						} elseif ('ΕΠΙΣΤΡΟΦΗ' == $current_status->description) {
							$order = wc_get_order($current_order_id);

							if ('deliverydenied' != $order->get_status()) {
								$order->update_status('deliverydenied');
							}
						}
					}//if not empty
				}//end foreach
			}//END IF
		}
	}//end for each order id
}//end acs trace voucher

function wpslash_acs_voucher_trace_bulk_api( $apikey, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $orders_ids) {
	global $woocommerce;
	foreach ($orders_ids as $current_order_id) {
		$current_tracking = get_post_meta($current_order_id, 'wpslash_voucher_courier_tracking', true);
		$current_courier  = get_post_meta($current_order_id, 'wpslash_voucher_courier', true);

		$acs_data                       = array();
		$acs_data['ACSAlias']           = 'ACS_TrackingDetails';
		$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
		'Company_Password' => $acs_company_password,
		'User_ID' => $acs_username,
		'User_Password' => $acs_password,
		'Language' => null,
		'Voucher_No' => $current_tracking, );

		$curl = curl_init();
		curl_setopt_array($curl, array(
		CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_ENCODING => '',
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => 'POST',
		CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
		CURLOPT_HTTPHEADER => array(
		'Access-Control-Request-Headers: *',
		'AcsApiKey: ' . $apikey . ' ',
		'Cache-Control: no-cache',
		'Content-Type: application/json',  ),
		));

		$response = curl_exec($curl);
		$err      = curl_error($curl);

		curl_close($curl);

		if ($err) {
			error_log($err);
		} else {
			$result = json_decode($response);

			if ('' == $result->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
				if (!empty($result->ACSOutputResponce->ACSTableOutput->Table_Data)) {
					foreach ($result->ACSOutputResponce->ACSTableOutput->Table_Data as $current_status) {
						if (!empty($current_status->checkpoint_location)) {
							if ('ΠΑΡΑΔΟΣΗ' == $current_status->checkpoint_action) {
								$order = wc_get_order($current_order_id);

								if ('deliverycompleted' != $order->get_status()) {
									$order->update_status('deliverycompleted');
								}
							} elseif ('ΕΠΙΣΤΡΟΦΗ' == $current_status->checkpoint_action) {
								$order = wc_get_order($current_order_id);

								if ('deliverydenied' != $order->get_status()) {
									$order->update_status('deliverydenied');
								}
							}
						}//if not empty
					}//end foreach
				}//END IF
			} else {
				error_log($result->ACSOutputResponce->ACSValueOutput[0]->Error_Message);
			}

			/*  echo "<pre>";
			print_r($result);
			echo "</pre>";*/
		}
	}//end for each order id
}//end acs trace voucher

function wpslash_acs_voucher_get_mass_numbers( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date) {
	$response = null;

	$lang = 'GR';

	try {
		$client = new SoapClient('https://services.acscourier.net/ACSReceiptsList-portlet/axis/Plugin_ACSReceiptsList_MassNumberEntryService?wsdl');
		$result = $client->getMassNumbers($acs_company_id, $acs_company_password, $acs_username, $acs_password, $date, $lang);
	} catch (Exception $e) {
		// your loging regarding this case
		print_r($e);
	}
	$mass_numbers = array();
	if (!empty($result)) {
		foreach ($result as $current_mas) {
			$mass_numbers[] = $current_mas->massNumber;
		}
		$response = $mass_numbers;
	}//end if

	return $response;
}//end function acs_get_mass_numbers//

function wpslash_acs_voucher_get_mass_numbers_api( $apikey, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date) {
	$acs_data                       = array();
	$acs_data['ACSAlias']           = 'ACS_Get_Pickup_Lists';
	$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
	'Company_Password' => $acs_company_password,
	'User_ID' => $acs_username,
	'User_Password' => $acs_password,
	'Language' => null,
	'Pickup_Date' => $date, );

	//return var_dump(json_encode($acs_data,JSON_FORCE_OBJECT));

	$curl = curl_init();
	curl_setopt_array($curl, array(
	CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => '',
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => 'POST',
	CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
	CURLOPT_HTTPHEADER => array(
	'Access-Control-Request-Headers: *',
	'AcsApiKey: ' . $apikey . ' ',
	'Cache-Control: no-cache',
	'Content-Type: application/json',  ),
	));

	$response = curl_exec($curl);
	$err      = curl_error($curl);

	curl_close($curl);

	if ($err) {
		error_log($err);
	} else {
		$result       = json_decode($response);
		$mass_numbers = array();
		if ('' == $result->ACSOutputResponce->ACSValueOutput[0]->Error_Message || null == $result->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
			$mass_numbers = array();
			foreach ($result->ACSOutputResponce->ACSTableOutput->Table_Data as $current_mas) {
				$mass_numbers[] = $current_mas->PickupList_No;
			}
			$response = $mass_numbers;
		}//end if

		return $response;
	}
}//end function acs_get_mass_numbers//

function wpslash_acs_voucher_print_receipt_list( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date, $mass_number) {
	$pdf_data = wpslash_acs_voucher_get_contents('https://acs-eud2.acscourier.net/Eshops/getlist.aspx?MainID=' . $acs_company_id . '&MainPass=' . $acs_company_password . '&UserID=' . $acs_username . '&UserPass=' . $acs_password . '&MassNumber=' . $mass_number . '&DateParal=' . $date);

	if ($pdf_data) {
		echo esc_html(base64_encode($pdf_data));
	}
}//end function

function wpslash_acs_voucher_create_receipt_list( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date) {
	$response = null;
	$myData   = '0';

	try {
		$client = new SoapClient('https://services.acscourier.net/ACSReceiptsList-portlet/axis/Plugin_ACSReceiptsList_ACSReceiptsListService?wsdl');
		$result = $client->createACSReceiptsList($acs_company_id, $acs_company_password, $acs_username, $acs_password, $date, $myData);
	} catch (Exception $e) {
		print_r($e);
	}

	//if error show
	if (empty($result->massNumber) && !empty($result->error)) {
		//echo $result->error;
		$response = 'error';
	} else {
		$response = $result->massNumber;

		//echo $result->massNumber;
	}

	return $response;
}

function wpslash_acs_voucher_create_receipt_list_api( $apikey, $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date) {
	$acs_data                       = array();
	$acs_data['ACSAlias']           = 'ACS_Issue_Pickup_List';
	$acs_data['ACSInputParameters'] = array('Company_ID' => $acs_company_id,
	'Company_Password' => $acs_company_password,
	'User_ID' => $acs_username,
	'User_Password' => $acs_password,
	'Language' => null,
	'Pickup_Date' => $date, );

	//return var_dump(json_encode($acs_data,JSON_FORCE_OBJECT));

	$curl = curl_init();
	curl_setopt_array($curl, array(
	CURLOPT_URL => 'https://webservices.acscourier.net/ACSRestServices/api/ACSAutoRest',
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => '',
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => 'POST',
	CURLOPT_POSTFIELDS => $json = json_encode($acs_data, JSON_FORCE_OBJECT),
	CURLOPT_HTTPHEADER => array(
	'Access-Control-Request-Headers: *',
	'AcsApiKey: ' . $apikey . ' ',
	'Cache-Control: no-cache',
	'Content-Type: application/json',  ),
	));

	$response = curl_exec($curl);
	$err      = curl_error($curl);

	curl_close($curl);

	if ($err) {
		error_log($err);
	} else {
		$result = json_decode($response);

		//if error show
		if ('' != $result->ACSOutputResponce->ACSValueOutput[0]->Error_Message) {
			$unprinted_vouchers = array();
			foreach ($result->ACSOutputResponce->ACSTableOutput->Table_Data as $unprinted_voucher) {
				$unprinted_vouchers[] = $unprinted_voucher->Unprinted_Vouchers;
			}
			//echo $result->error;
			$response = $unprinted_vouchers;
		} else {
			$response = $result->ACSOutputResponce->ACSValueOutput[0]->PickupList_No;

			//echo $result->massNumber;
		}

		return $response;
	}
}

function wpslash_acs_voucher_get_unprinted_vouchers( $acs_company_id, $acs_company_password, $acs_username, $acs_password, $date) {
	$response = null;
	$myData   = '0';

	try {
		$client = new SoapClient('https://services.acscourier.net/ACSReceiptsList-portlet/axis/Plugin_ACSReceiptsList_ACSUnprintedPodsService?wsdl');
		$result = $client->getUnprintedPods($acs_company_id, $acs_company_password, $acs_username, $acs_password, $date, $myData);
	} catch (Exception $e) {
		// your loging regarding this case
		print_r($e);
	}

	$list_pods = array();

	if ($result) {
		foreach ($result as $current_pod) {
			$list_pods[] = $current_pod->no_pod;
		}
	}

	return $list_pods;
}//end function

function wpslash_acs_voucher_get_contents( $Url) {
	if (!function_exists('curl_init')) {
		die('CURL is not installed!');
	}
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $Url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$output = curl_exec($ch);
	curl_close($ch);

	return $output;
}
