<?php
if ( ! function_exists( 'wpslash_voucher_pdf_viewer' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_pdf_viewer', 'wpslash_voucher_pdf_viewer' );
	function wpslash_voucher_pdf_viewer() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );
		if ( isset( $_POST['base64_pdf'] ) ) {
			$base64_pdf = sanitize_text_field( $_POST['base64_pdf'] );
			$data       = base64_decode( $base64_pdf );
			header( 'Content-Type: application/pdf' );
			header( 'Cache-Control: private', false ); // required for certain browsers
			header( 'Content-Disposition: inline; filename="Voucher.PDF"' );
			header( 'Content-Transfer-Encoding: binary' );
			header( 'Accept-Ranges: bytes' );
			header( 'Cache-control: private' );
			header( 'Pragma: private' );
			header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
			var_dump( $data );
		}

		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_pdf_viewer_iframed' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_pdf_viewer_iframed', 'wpslash_voucher_pdf_viewer_iframed' );
	function wpslash_voucher_pdf_viewer_iframed() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );
		if ( isset( $_POST['base64_pdf'] ) ) {
			


			if ('large_file_created' == $_POST['base64_pdf']  ) {
				$upload_dir   = wp_upload_dir();
				$temp_dir = $upload_dir['basedir'] . '/temp_vouchers';
				$pdf_contents = file_get_contents($temp_dir . '/final.pdf');
				$pdf_encoded_contents = base64_encode($pdf_contents);
				$pdf_data = 'data:application/pdf;base64,' . $pdf_encoded_contents; ?>
			<a class="button" onclick="document.getElementById('wpslash_iframedpdf').contentWindow.print();"
			   style="display: inline-block;text-decoration: none;font-size: 13px;line-height: 26px;height: 28px;margin: 0;padding: 0 10px 1px;cursor: pointer;border-width: 1px;border-style: solid;-webkit-appearance: none;-webkit-border-radius: 3px;border-radius: 3px;white-space: nowrap;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;color: #555;border-color: #ccc;background: #f7f7f7;-webkit-box-shadow: 0 1px 0 #ccc;box-shadow: 0 1px 0 #ccc;vertical-align: top;"><?php esc_html_e( 'Print Voucher', 'wpslash-acs-voucher' ); ?></a>
			<iframe name="wpslash_iframedpdf" id="wpslash_iframedpdf" src="<?php echo esc_html($pdf_data); ?>" width="100%;" height="100%"
					style="width:100%;height:100%;"></iframe>


				<?php
			} else {
				$base64_pdf = sanitize_text_field( $_POST['base64_pdf'] ); 
				?>
			<a class="button" onclick="document.getElementById('wpslash_iframedpdf').contentWindow.print();"
			   style="display: inline-block;text-decoration: none;font-size: 13px;line-height: 26px;height: 28px;margin: 0;padding: 0 10px 1px;cursor: pointer;border-width: 1px;border-style: solid;-webkit-appearance: none;-webkit-border-radius: 3px;border-radius: 3px;white-space: nowrap;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;box-sizing: border-box;color: #555;border-color: #ccc;background: #f7f7f7;-webkit-box-shadow: 0 1px 0 #ccc;box-shadow: 0 1px 0 #ccc;vertical-align: top;"><?php esc_html_e( 'Print Voucher', 'wpslash-acs-voucher' ); ?></a>
			<form id="wpslash_voucher_iframe_post" target="wpslash_iframedpdf"
				  method="post" action="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>?pdf">
				<input type="hidden" name="action" value="wpslash_voucher_pdf_viewer"/>
				<input type="hidden" name="base64_pdf" value="<?php echo esc_html( $base64_pdf ); ?>"/>
				<input type="hidden" name="security"
					   value="<?php echo esc_html( wp_create_nonce( 'wpslash_voucher_nonce' ) ); ?>"/>


			</form>
			<iframe name="wpslash_iframedpdf" id="wpslash_iframedpdf" width="100%;" height="100%"
					style="width:100%;height:100%;"></iframe>

			<script type="text/javascript">
				window.onload = function () {
					document.getElementById('wpslash_voucher_iframe_post').submit();
				}

			</script>

				<?php

			}


		}

		

		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_parcel_count_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_parcel_count_change_ajax', 'wpslash_voucher_parcel_count_change_ajax' );

	function wpslash_voucher_parcel_count_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_count'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_count', sanitize_text_field( $_POST['wpslash_voucher_count'] ) );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_weight_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_weight_change_ajax', 'wpslash_voucher_weight_change_ajax' );

	function wpslash_voucher_weight_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_weight'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_weight', floatval( $_POST['wpslash_voucher_weight'] ) );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_charge_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_charge_change_ajax', 'wpslash_voucher_charge_change_ajax' );

	function wpslash_voucher_charge_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_charge'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_charge', sanitize_text_field( $_POST['wpslash_voucher_charge'] ) );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_sat_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_sat_change_ajax', 'wpslash_voucher_sat_change_ajax' );

	function wpslash_voucher_sat_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_sat'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_sat', (int) $_POST['wpslash_voucher_sat'] );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_rdo_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_rdo_change_ajax', 'wpslash_voucher_rdo_change_ajax' );

	function wpslash_voucher_rdo_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_rdo'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_rdo', (int) $_POST['wpslash_voucher_rdo'] );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_rec_change_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_rec_change_ajax', 'wpslash_voucher_rec_change_ajax' );

	function wpslash_voucher_rec_change_ajax() {
		global $woocommerce;
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		if ( isset( $_POST['wpslash_voucher_order_id'] ) && isset( $_POST['wpslash_voucher_rec'] ) ) {
			$order_id = (int) $_POST['wpslash_voucher_order_id'];
			$order    = wc_get_order( $order_id );

			$order->update_meta_data( 'wpslash_voucher_rec', (int) $_POST['wpslash_voucher_rec'] );
			$order->save();
		}
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_generate_popup' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_generate_popup', 'wpslash_voucher_generate_popup' );

	function wpslash_voucher_generate_popup() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );
		if ( isset( $_POST['courier'] ) ) {
			$courier = sanitize_text_field( $_POST['courier'] );
			global $woocommerce;

			do_action( 'wpslash_voucher_generate_popup_main' );
		}

		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_print_voucher_pdf_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_print_voucher_pdf_ajax', 'wpslash_voucher_print_voucher_pdf_ajax' );

	function wpslash_voucher_print_voucher_pdf_ajax() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		do_action( 'wpslash_voucher_print_pdf_main' );

		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_trace_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_trace_ajax', 'wpslash_voucher_trace_ajax' );

	function wpslash_voucher_trace_ajax() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		global $post;
		do_action( 'wpslash_voucher_trace_main' );
		wp_die();
	}
}
if ( ! function_exists( 'wpslash_voucher_courier_cancel_ajax' ) ) {
	add_action( 'wp_ajax_wpslash_voucher_courier_cancel_ajax', 'wpslash_voucher_courier_cancel_ajax' );
	function wpslash_voucher_courier_cancel_ajax() {
		check_ajax_referer( 'wpslash_voucher_nonce', 'security' );

		do_action( 'wpslash_voucher_cancel_main' );
		wp_die();
	}
}

if ( ! function_exists( 'wpslash_voucher_get_contents' ) ) {
	function wpslash_voucher_get_contents( $Url ) {
		if ( ! function_exists( 'curl_init' ) ) {
			die( 'CURL is not installed!' );
		}
		$ch = curl_init();
		curl_setopt( $ch, CURLOPT_URL, $Url );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		$output = curl_exec( $ch );
		curl_close( $ch );

		return $output;
	}
}
?>
