<?php
if (!function_exists('wpslash_voucher_get_instances_by_courier')) {
	function wpslash_voucher_get_instances_by_courier() {
		$couriers = wpslash_voucher_get_couriers();
		$instances =  array();
		foreach ($couriers as $courier_key => $courier_name) {
			$instances[$courier_key][$courier_key] = $courier_name;

			$courier_number_instances = get_option('wc_settings_tab_wpslash_voucher_global_' . $courier_key . '_instances', true); 
			if ($courier_number_instances > 1) {
				for ($i = 2; $i <= $courier_number_instances; $i++) {
						$instances[$courier_key][$courier_key . '_' . $i] = $courier_name . ' ' . $i;


				}
			}

		}
		return apply_filters('wpslash_voucher_courier_instances_by_courier_list_array', $instances);
	}
}



if (!function_exists('wpslash_voucher_get_couriers')) {
	function wpslash_voucher_get_couriers() {
		$couriers = array();
		return apply_filters('wpslash_voucher_courier_list_array', $couriers);
	}
}

if (!function_exists('wpslash_voucher_get_courier_extra_services')) {
	function wpslash_voucher_get_courier_extra_services() {
		$extra_services = array();
		return apply_filters('wpslash_voucher_courier_extra_services', $extra_services);
	}
}

if (!function_exists('wpslash_voucher_get_courier_extra_services_by_courier')) {
	function wpslash_voucher_get_courier_extra_services_by_courier( $courier_key) {
		$courier_extra_services = wpslash_voucher_get_courier_extra_services();
		if (array_key_exists($courier_key, $courier_extra_services)) {
			return $courier_extra_services[$courier_key]; 
		}
	}
}

if (!function_exists('wpslash_voucher_get_courier_extra_service_by_service_key')) {
	function wpslash_voucher_get_courier_extra_service_by_service_key( $courier_key, $service_key) {
		$courier_extra_services = wpslash_voucher_get_courier_extra_services();
		if (array_key_exists($courier_key, $courier_extra_services)) {
			$courier_services = $courier_extra_services[$courier_key];

			if (array_key_exists($service_key, $courier_services)) {
					return $courier_services[$service_key];
			}
		}
	}
}


if (!function_exists('wpslash_voucher_get_courier_parcel_types')) {
	function wpslash_voucher_get_courier_parcel_types() {
		$parcel_types = array();
		return apply_filters('wpslash_voucher_courier_parcel_types', $parcel_types);
	}
}

if (!function_exists('wpslash_voucher_get_courier_parcel_types_by_courier')) {
	function wpslash_voucher_get_courier_parcel_types_by_courier( $courier_key) {
		$courier_parcel_types = wpslash_voucher_get_courier_parcel_types();
		if (array_key_exists($courier_key, $courier_parcel_types)) {
			return $courier_parcel_types[$courier_key]; 
		}
	}
}

if (!function_exists('wpslash_voucher_get_courier_parcel_type_by_service_key')) {
	function wpslash_voucher_get_courier_parcel_type_by_service_key( $courier_key, $service_key) {
		$courier_parcel_types = wpslash_voucher_get_courier_parcel_types();
		if (array_key_exists($courier_key, $courier_parcel_types)) {
			$parcel_types = $courier_parcel_types[$courier_key];

			if (array_key_exists($service_key, $parcel_types)) {
					return $parcel_types[$service_key];
			}
		}
	}
}

if (!function_exists('wpslash_voucher_get_all_courier_instances')) {
	function wpslash_voucher_get_all_courier_instances() {
		$couriers = wpslash_voucher_get_couriers();
		$instances =  array();
		foreach ($couriers as $courier_key => $courier_name) {
			$instances[$courier_key] = $courier_name;

			$courier_number_instances = get_option('wc_settings_tab_wpslash_voucher_global_' . $courier_key . '_instances', true); 
			if ($courier_number_instances > 1) {
				for ($i = 2; $i <= $courier_number_instances; $i++) {
						$instances[$courier_key . '_' . $i] = $courier_name . ' ' . $i;


				}
			}

		}
		return apply_filters('wpslash_voucher_all_courier_instances_list_array', $instances);
	}
}


