<?php
if (!function_exists('wpslash_voucher_register_delivery_completed_order_status')) {
	function wpslash_voucher_register_delivery_completed_order_status() {
		register_post_status( 'wc-deliverycompleted', array(
		'label'                     => __('Delivery Completed', 'wpslash-acs-voucher'),
		'public'                    => true,
		'show_in_admin_status_list' => true,
		'show_in_admin_all_list'    => true,
		'exclude_from_search'       => false,
		/* translators: %s: Delivery Completed Status */ 
		'label_count'               => _n_noop( 'Delivery Completed <span class="count">(%s)</span>', 'Delivery Completed <span class="count">(%s)</span>', 'greek-courier-voucher' )

		) );

		register_post_status( 'wc-deliverydenied', array(
		'label'                     => __('Delivery Denied', 'wpslash-acs-voucher'),
		'public'                    => true,
		'show_in_admin_status_list' => true,
		'show_in_admin_all_list'    => true,
		'exclude_from_search'       => false,
			/* translators: %s: Delivery Denied Status */ 
		'label_count'               => _n_noop( 'Delivery Denied <span class="count">(%s)</span>', 'Delivery Denied <span class="count">(%s)</span>', 'greek-courier-voucher' )

		) );
	}


	add_action( 'init', 'wpslash_voucher_register_delivery_completed_order_status' );

}

if (!function_exists('wpslash_voucher_add_delivery_completed_to_order_statuses')) {
	function wpslash_voucher_add_delivery_completed_to_order_statuses( $order_statuses ) {
		$new_order_statuses = array();
		foreach ( $order_statuses as $key => $status ) {
			$new_order_statuses[ $key ] = $status;
			if ( 'wc-completed' === $key ) {
				$new_order_statuses['wc-deliverycompleted'] = __( 'Delivery Completed', 'wpslash-acs-voucher' );
				$new_order_statuses['wc-deliverydenied']    = __( 'Delivery Denied', 'wpslash-acs-voucher' );

			}
		}
		return $new_order_statuses;
	}

	add_filter( 'wc_order_statuses', 'wpslash_voucher_add_delivery_completed_to_order_statuses', 10, 1 );
}

if (!function_exists('wpslash_voucher_custom_order_status_to_reports')) {
	add_filter( 'woocommerce_reports_order_statuses', 'wpslash_voucher_custom_order_status_to_reports', 20, 1 );
	function wpslash_voucher_custom_order_status_to_reports( $statuses ) {
		// Adding the custom order status to the 3 default woocommerce order statuses

		$statuses[] = 'deliverycompleted';
		$statuses[] = 'deliverydenied';

		return $statuses;
	}
}

if (!function_exists('wpslash_voucher_styling_deliverycompleted')) {
	add_action('admin_head', 'wpslash_voucher_styling_deliverycompleted' );
	function wpslash_voucher_styling_deliverycompleted() {
		global $pagenow, $post;

		if ( 'edit.php' != $pagenow) {
			return; // Exit
		}
		if ( get_post_type($post->ID) != 'shop_order' ) {
			return; // Exit
		}
		?>
<style>
  .order-status.status-deliverycompleted  {
	background: #1dae3c;
	color: white;
  }
  .order-status.status-deliverydenied {
	background: #000000;
	color: white;
  }
</style>
		<?php
	}
}
?>
