<?php

if (!function_exists('wpslash_voucher_add_settings_tab')) {
	add_action('woocommerce_settings_tabs', 'wpslash_voucher_add_settings_tab');
	function wpslash_voucher_add_settings_tab() {
		//link to custom tab
		$current_tab = ( 'wpslash_voucher' == isset($_GET['tab']) ) ? 'nav-tab-active' : '';
		echo '<a href="admin.php?page=wc-settings&amp;tab=wpslash_voucher" class="nav-tab ' . esc_html($current_tab) . '">' . esc_html__('WPSlash Voucher Settings', 'wpslash-acs-voucher') . '</a>';
	}

}

if (!function_exists('wpslash_voucher_tab_content')) {
	add_action('woocommerce_settings_wpslash_voucher', 'wpslash_voucher_tab_content');
	function wpslash_voucher_tab_content() {
		?>

		<ul class="subsubsub">
				<?php	
							$is_current_section ='';	
				if (isset($_GET['section'])) {
					if ('global' == $_GET['section']) {
						$is_current_section = 'current';

					}

				} else {
					$is_current_section = 'current';

				}

				?>
			<li><a href="admin.php?page=wc-settings&amp;tab=wpslash_voucher&amp;section=global" class="<?php echo esc_html($is_current_section); ?>"><?php esc_html_e('Global Settings', 'wpslash-acs-voucher'); ?></a> | </li>

			<?php foreach (wpslash_voucher_get_all_courier_instances() as $courier_instance=>$courier_instance_name) : ?>
							<?php	
							$is_current_section ='';	
							if (isset($_GET['section'])) {
								if ($courier_instance == $_GET['section']) {
									$is_current_section = 'current';

								}

							}

							?>

			<li><a href="admin.php?page=wc-settings&amp;tab=wpslash_voucher&amp;section=<?php echo esc_html($courier_instance); ?>" class="<?php echo esc_html($is_current_section); ?>"><?php echo esc_html($courier_instance_name); ?></a> | </li>

			<?php endforeach; ?>
		</ul>
		<br class="clear">
		<?php


		do_action('wpslash_voucher_render_settings');

		woocommerce_admin_fields(wpslash_voucher_global_get_settings());
	}
}

if (!function_exists('wpslash_voucher_global_get_settings')) {
	function wpslash_voucher_global_get_settings() {
		if ( ( isset($_GET['section']) && 'global' === $_GET['section'] ) || !isset($_GET['section']) ) {
			$shipping_methods = WC()->shipping->get_shipping_methods();
			$shipping_methods_array = array();
			foreach ($shipping_methods as $shipping_method_id => $shipping_method) {
				$shipping_methods_array[$shipping_method_id] = $shipping_method->method_title;

			}

			$courier_list   = wpslash_voucher_get_couriers();

			$settings = array(
			'section_title' => array(
			'name' => esc_html__('Global Settings', 'wpslash-acs-voucher'),
			'type' => 'title',
			'desc' => '',
			'id' => 'wc_settings_tab_wpslash_global_voucher_section_title',
			));
			foreach ($courier_list as $courier_key=>$courier_name) {
				$settings['courier_' . $courier_key . '_instances'] =  array(
				'name' => $courier_name . ' ' . esc_html__('instances you will run', 'wpslash-acs-voucher'),
				'type' => 'number',
				'desc' => esc_html__('Select how many instances you will run. The most of you will need only 1 instance. In case you have multiple credentials you can use them by selecting multiple instances', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_voucher_global_' . $courier_key . '_instances',
				'default'=>1
				);

			}
			$settings['weight_calculation'] = array(
			'name' => __( 'Weight Calculation', 'wpslash-acs-voucher' ),
			'type' => 'select',
			'desc' => __( 'How do you want the voucher weight being calculated', 'wpslash-acs-voucher' ),
			'id'   => 'wc_settings_tab_wpslash_global_voucher_weight_calculation',
			'options' => array(
				'fixed'       => __( 'Fixed(Set Weight in KG below)', 'wpslash-acs-voucher' ),
				'auto'        => __( 'Automatic(Based on Cart Weight)', 'wpslash-acs-voucher' )
			),
			'default' => 'fixed'
			); 
			$settings['weight_fixed'] = array(
			'name' => __( 'Fixed Weight', 'wpslash-acs-voucher' ),
			'type' => 'text',
			'desc' => __( 'Set the weight if you choosen Fixed Weight above', 'wpslash-acs-voucher' ),
			'id'   => 'wc_settings_tab_wpslash_global_voucher_weight_fixed',
			'default' => '1',

			);
			$settings['weight_rewrite'] = array(
			'name' => __( 'Weight Rewrite', 'wpslash-acs-voucher' ),
			'type' => 'checkbox',
			'desc' => 'Enable this option if you want to be able to rewrite the weight of the order (bypassing the fixed weight or the automatic weight)',
			'id'   => 'wc_settings_tab_wpslash_global_voucher_weight_rewrite'
			);

			$settings['automatic_generation_enabled'] =  array(
			'name' => esc_html__('Enable Automatic Voucher Generation on Complete', 'wpslash-acs-voucher'),
			'type' => 'checkbox',
			'desc' => esc_html__('By Enabling this feature the voucher will automatically generated when you change the status to completed. Dont forget to select the courier. ', 'wpslash-acs-voucher'),
			'id' => 'wc_settings_tab_wpslash_voucher_global_automatic_generation_enabled',
			);
			$settings['automatic_generation_courier'] = array(
			'name' => esc_html__('Select Couriers', 'wpslash-acs-voucher'),
			'type' => 'multiselect',
			'desc' => esc_html__('Select Couriers you want for automatic voucher creation', 'wpslash-acs-voucher'),
			'id' => 'wc_settings_tab_wpslash_voucher_global_automatic_generation_courier',
			'options' => wpslash_voucher_get_all_courier_instances(),
			);
			$settings['shipping_methods_enabled'] = array(
			'name' => esc_html__('On Which Methods a Voucher should be Generated', 'wpslash-acs-voucher'),
			'type' => 'multiselect',
			'desc' => esc_html__('Leave it empty for all shipping methods or select the  methods you want. This setting applies only to  auto-generated vouchers. You will still be able to generate a voucher manually even if the shipping method is not in the list.', 'wpslash-acs-voucher'),
			'id' => 'wc_settings_tab_wpslash_voucher_global_shipping_method_enabled',
			'options' => $shipping_methods_array,
			);

			$settings['section_end'] = array(
			'type' => 'sectionend',
			'id' => 'wc_settings_tab_wpslash_global_voucher_section_end',
			);
	

			return apply_filters('wc_settings_tab_wpslash_global_voucher_settings', $settings);
		}
	}// end if isset global settings//



}


if (!function_exists('save_wpslash_voucher_settings')) {
	add_action('woocommerce_settings_save_wpslash_voucher', 'save_wpslash_voucher_settings');

	function save_wpslash_voucher_settings() {
		do_action('wpslash_voucher_save_settings');
		woocommerce_update_options(wpslash_voucher_global_get_settings());
	}
}




