<?php

//add extra column courier and courier tracking  on orders list//
if (!function_exists('wpslash_voucher_shop_order_column')) {
	add_filter('manage_edit-shop_order_columns', 'wpslash_voucher_shop_order_column', 12);
	function wpslash_voucher_shop_order_column( $columns) {
		//add columns
		$columns['wpslash_voucher_settings'] = esc_html__('Voucher Settings', 'wpslash-acs-voucher');

		$columns['wpslash_voucher'] = esc_html__('Voucher', 'wpslash-acs-voucher');

		$columns['wpslash_voucher_courier'] = esc_html('Courier', 'wpslash-acs-voucher');
		$columns['wpslash_voucher_courier_tracking'] = esc_html__('Tracking', 'wpslash-acs-voucher');

		return $columns;
	}
}

if (!function_exists('wpslash_voucher_shop_order_bulk_actions')) {
	add_filter( 'bulk_actions-edit-shop_order', 'wpslash_voucher_shop_order_bulk_actions' );
 
	function wpslash_voucher_shop_order_bulk_actions( $bulk_actions) {
		$bulk_actions['wpslash_voucher_generate_default'] = __( 'Generate Vouchers based on Global Settings', 'wpslash-acs-voucher');
		return $bulk_actions;
	}
}

if (!function_exists('wpslash_voucher_shop_order_bulk_action_handler')) {
	add_filter( 'handle_bulk_actions-edit-shop_order', 'wpslash_voucher_shop_order_bulk_action_handler', 10, 3 );
 
	function wpslash_voucher_shop_order_bulk_action_handler( $redirect_to, $action, $post_ids ) {

		if ( 'wpslash_voucher_generate_default' === $action ) {

			$wpslash_voucher_global_completed_courier =  get_option( 'wc_settings_tab_wpslash_voucher_global_automatic_generation_courier' );

			foreach ( $post_ids as $post_id ) {

				if (wpslash_voucher_check_if_can_auto_created($post_id)) {
					do_action('wpslash_voucher_status_changed_to_completed_global', $wpslash_voucher_global_completed_courier, $post_id);
				

				}

			}
			$redirect_to = add_query_arg( 'wpslash_voucher_generated_notice', count( $post_ids ), $redirect_to );


		}
			  return $redirect_to;
	}
}
if (!function_exists('wpslash_voucher_generated_admin_notice')) {

	add_action( 'admin_notices', 'wpslash_voucher_generated_admin_notice' );

	function wpslash_voucher_generated_admin_notice() { 
		if ( ! empty( $_REQUEST['wpslash_voucher_generated_notice'] ) ) {
			$orders_count = intval( $_REQUEST['wpslash_voucher_generated_notice'] );
			printf( '<div id="message" class="updated fade">' .
			sprintf( 'Processed %s Orders.',
			  '%s',
			  esc_html($orders_count),
			  'wpslash-acs-voucher'
			) . '</div>', esc_html($orders_count) );
		}
	}
}

if (!function_exists('wpslash_voucher_list_column_buttons')) {
	add_action('manage_shop_order_posts_custom_column', 'wpslash_voucher_list_column_buttons', 10, 3);
	function wpslash_voucher_list_column_buttons( $column) {
		global $post, $woocommerce, $the_order;
		$order_id = $post->ID;

		$wpslash_voucher_instances_by_courier_list = wpslash_voucher_get_instances_by_courier();
		$wpslash_voucher_all_instances = wpslash_voucher_get_all_courier_instances();

		switch ($column) {
			case 'wpslash_voucher':
				//$myVarOne = wc_get_order_item_meta( $order_id, 'Some Field', true );
				$myVarOne = get_post_meta($order_id, 'wpslash_voucher_courier', true);

				// create some tooltip text to show on hover
				$tooltip = esc_html__('Voucher Actions from Greek Courier Web Services.', 'wpslash-acs-voucher');

				// create a button label
				$label = esc_html__('Voucher', 'wpslash-acs-voucher');

				echo '<div class="dropdown">
    <a class="wpslash_voucher_dropbtn_options"  order-id="' . esc_html($order_id) . '">' . esc_html($label) . '</a>';
				echo '</div>';

				echo '<div id="wpslash_voucher_dropbtn_content_' . esc_html($order_id) . '" class="dropdown-content">';

				foreach ($wpslash_voucher_instances_by_courier_list  as $courier => $instances) {

					foreach ($instances as $instance_key => $instance_name) {
						if ( 'yes' === get_option('wc_settings_tab_wpslash_' . $instance_key . '_voucher_enabled', true)) {
							echo '<a class="wpslash_voucher_courier" courier="' . esc_html($courier) . '" order-id="' . esc_html($order_id) . '" instance-id="' . esc_html($instance_key) . '" >' . esc_html($instance_name) . '</a>';
						}

					}
					


				}

				echo '</div>';

				break;

			case 'wpslash_voucher_courier':
				$courier_key = get_post_meta($order_id, 'wpslash_voucher_courier', true);
				$instance_id = get_post_meta($order_id, 'wpslash_voucher_courier_instance_id', true);
				if (!$instance_id) {
					echo esc_html($wpslash_voucher_all_instances[$courier_key]);

				} else {
					echo esc_html($wpslash_voucher_all_instances[$instance_id]);

				}
				break;

			case 'wpslash_voucher_courier_tracking':
				$courier_tracking = get_post_meta($order_id, 'wpslash_voucher_courier_tracking', true);
				if (!empty($courier_tracking)) {
					echo esc_html($courier_tracking);
				}
				break;

			case 'wpslash_voucher_settings':
				$recipient_charge_active = false;
				$extra_services_enabled = array();
				$weight_rewrite_active = false;
				$global_weight_rewrite = get_option('wc_settings_tab_wpslash_global_voucher_weight_rewrite', true);
				if ('yes'===$global_weight_rewrite ) {
					$weight_rewrite_active = true;

				}

				foreach ($wpslash_voucher_all_instances as $courier_key => $courier_name) {
					$current_courier_recipient_charge = get_option('wc_settings_tab_wpslash_' . $courier_key . '_voucher_recipient_charge', true);
					$current_courier_extra_services_enabled = get_option('wc_settings_tab_wpslash_' . $courier_key . '_voucher_extra_services_enabled', true);
	
					if ('yes' === $current_courier_recipient_charge) {
						$recipient_charge_active = true;
					}
					if (!empty($current_courier_extra_services_enabled)) {

						$extra_services_enabled[$courier_key] = $current_courier_extra_services_enabled;
					}
				
				}

				$wpslash_voucher_charge = get_post_meta($order_id, 'wpslash_voucher_charge', true);
				$wpslash_voucher_weight = wpslash_voucher_get_order_weight($order_id);

				$wpslash_voucher_count = get_post_meta($order_id, 'wpslash_voucher_count', true); ?>
			<input type="hidden" value="<?php echo esc_html($order_id); ?>"/> 
			<label><?php esc_html_e('Parcel Count', 'wpslash-acs-voucher'); ?></label>
				<?php

				if ($wpslash_voucher_count) : 
					?>
					<input min="1" type="number" value="<?php echo esc_html($wpslash_voucher_count); ?>"  class="wpslash_voucher_count"/>
					<?php else : ?>
				<input  min="1" type="number" value="1"  class="wpslash_voucher_count"/> 
				<?php endif; ?>
				<a class="button wpslash_voucher_count_change" order-id="<?php echo esc_html($order_id); ?>"><?php esc_html_e('Change', 'wpslash-acs-voucher'); ?></a> 
				<hr/>


				<?php
				if ($recipient_charge_active) : 
					?>

					<label><?php esc_html_e('Charge', 'wpslash-acs-voucher'); ?></label>

				<select  class="wpslash_voucher_charge" order-id="<?php echo esc_html($order_id); ?>">
					<?php if (2 == $wpslash_voucher_charge) : ?>
					<option value="1" ><?php esc_html_e('Sender', 'wpslash-acs-voucher'); ?></option>

					<option value="2" selected><?php esc_html_e('Recipient', 'wpslash-acs-voucher'); ?></option>
				<?php else : ?>
					<option value="1" selected><?php esc_html_e('Sender', 'wpslash-acs-voucher'); ?></option>

					<option value="2"><?php esc_html_e('Recipient', 'wpslash-acs-voucher'); ?></option>
				<?php endif; ?>

				</select>

				<?php endif; ?>

					<?php
					if ( $weight_rewrite_active ) :
						?>

					<label><?php esc_html_e( 'Weight', 'wpslash-acs-voucher' ); ?></label>
					<input type="number" step="0.01" value="<?php echo esc_html( $wpslash_voucher_weight ); ?>"
						   placeholder=""/>
					<a class="button wpslash_voucher_weight_change"
					   order-id="<?php echo esc_html( $order_id ); ?>"><?php esc_html_e( 'Change', 'wpslash-acs-voucher' ); ?></a>
					<hr/>

				<?php endif; ?>

				<?php

				do_action('wpslash_voucher_shop_order_settings_after_charge', $order_id);

				$wpslash_voucher_sat = get_post_meta($order_id, 'wpslash_voucher_sat', true); 
				?>
				<label><?php esc_html_e('Saturday Delivery', 'wpslash-acs-voucher'); ?></label>

				<?php if (1 == $wpslash_voucher_sat) : ?>
					<input type="checkbox" class="wpslash_voucher_sat" value="1" order-id="<?php echo esc_html($order_id); ?>" checked/>
				<?php else : ?>
					<input type="checkbox" class="wpslash_voucher_sat" value="0" order-id="<?php echo esc_html($order_id); ?>"/>
				<?php endif; ?>
				<hr/>
				<?php if (!empty($extra_services_enabled)) : ?>
					<?php $all_extra_services  = wpslash_voucher_get_courier_extra_services(); ?>
					<?php $wpslash_voucher_extra_services = get_post_meta($order_id, 'wpslash_voucher_extra_services', true); ?>

					<?php foreach (array_keys($extra_services_enabled) as $courier_key) : ?>
							<?php if (!empty($extra_services_enabled[$courier_key]) && !empty($wpslash_voucher_extra_services)) : ?>
							<div class="wpslash_voucher_extra_services_wrapper">
							<label><?php echo esc_html($wpslash_voucher_all_instances[$courier_key]) . ' ' . esc_html__('Extra Services', 'wpslash-acs-voucher'); ?></label>
								<?php foreach ($extra_services_enabled[$courier_key] as $extra_service) : ?>
											
											<?php $checked = in_array($extra_service, $wpslash_voucher_extra_services) ? ' checked':''; ?>
											<label><?php echo esc_html($all_extra_services[$courier_key][$extra_service]); ?></label>
											<input type="checkbox" class="wpslash_voucher_extra_services" value="<?php echo esc_html($extra_service); ?>" order-id="<?php echo esc_html($order_id); ?>" <?php echo esc_html($checked); ?> />
								


								 <?php endforeach; ?>

								</div> 
							<?php endif; ?>
					<?php endforeach; ?>
				<?php endif; ?>

				<?php 
				break;
		}
	}
}

if (!function_exists('wpslash_voucher_search_fields')) {
	add_filter('woocommerce_shop_order_search_fields', 'wpslash_voucher_search_fields');
	function wpslash_voucher_search_fields( $search_fields) {
		$search_fields[] = 'wpslash_voucher_courier';
		$search_fields[] = 'wpslash_voucher_courier_tracking';    //example
		return $search_fields;
	}
}

if (!function_exists('wpslash_voucher_shoporder_admin_css')) {
	function wpslash_voucher_shoporder_admin_css( $hook) {
		// $hook is string value given add_menu_page function.

		global $typenow;

		if ('shop_order' === $typenow) {
			
			wp_enqueue_style('wpslash_voucher_admin_order_css', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . '/css/admin.css', array(), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);
			wp_enqueue_script('wpslash_voucher_admin_order_js', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . '/js/admin.js', array('jquery'), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);

			wp_localize_script('wpslash_voucher_admin_order_js', 'wpslash_voucherajax', array(
			'ajaxurl' => admin_url('admin-ajax.php'),
			'ajax_nonce' => wp_create_nonce('wpslash_voucher_nonce'),
			));
		}
		if ('woocommerce_page_wc-settings' === $hook && isset($_GET['tab']) && ( 'wpslash_voucher' === $_GET['tab'] )) {
			wp_enqueue_style('wpslash-voucher-wc-settings-style', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . '/css/admin.wc-settings.css', array(), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);
			wp_register_style( 'wpslash-voucher-select2css', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'css/lib/select2.min.css', false, WPSLASH_ACS_VOUCHER_PLUGIN_VERSION);
			wp_register_script( 'wpslash-voucher-select2', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'js/lib/select2.min.js', array( 'jquery' ), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION, true );
			wp_register_script( 'wpslash-voucher-wc-settings', WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL . 'js/admin.wc-settings.js', array( 'jquery', 'wpslash-voucher-select2' ), WPSLASH_ACS_VOUCHER_PLUGIN_VERSION, true );
			wp_enqueue_style( 'wpslash-voucher-select2css' );
			wp_enqueue_script( 'wpslash-voucher-select2' );
			wp_enqueue_script( 'wpslash-voucher-wc-settings' );
		}
	}
	add_action('admin_enqueue_scripts', 'wpslash_voucher_shoporder_admin_css');
}

if (!function_exists('wpslash_voucher_add_no_link_to_order_list')) {
	function wpslash_voucher_add_no_link_to_order_list( $classes) {
		if (current_user_can('manage_woocommerce')) { //make sure we are shop managers
			foreach ($classes as $class) {
				if ('type-shop_order' == $class) {
					$classes[] = 'no-link';
				}
			}
		}

		return $classes;
	}
	add_filter('post_class', 'wpslash_voucher_add_no_link_to_order_list');
}

if (!function_exists('wpslash_voucher_dialog_pdf')) {
	function wpslash_voucher_dialog_pdf() {
		global $woocommerce;
		echo '
  <div class="wpslash_voucher_dialog_pdf" id="wpslash_voucher_dialog_pdf">
    <div class="dialog">
      <div class="content">
      </div>
      <div class="results">
      </div>
    </div>
  </div>
  <div class="wpslash_voucher_loading">Loading&#8230;</div>

  ';
	}

	add_action('admin_footer', 'wpslash_voucher_dialog_pdf', 100);
}
if (!function_exists('wpslash_voucher_handle_courier_query_var')) {
	function wpslash_voucher_handle_courier_query_var( $query, $query_vars ) {
		if ( ! empty( $query_vars['wpslash_voucher_courier'] ) ) {
			$query['meta_query'][] = array(
			'key' => 'wpslash_voucher_courier',
			'value' => esc_attr( $query_vars['wpslash_voucher_courier'] ),
			);
		}
		if ( ! empty( $query_vars['wpslash_voucher_courier_date'] ) ) {
			$query['meta_query'][] = array(
			'key' => 'wpslash_voucher_courier_date',
			'value' => esc_attr( $query_vars['wpslash_voucher_courier_date'] ),
			);
		}
		if ( ! empty( $query_vars['wpslash_voucher_courier_instance_id'] ) ) {
			$query['meta_query'][] = array(
			'key' => 'wpslash_voucher_courier_instance_id',
			'value' => esc_attr( $query_vars['wpslash_voucher_courier_instance_id'] ),
			);
		}
		

		return $query;
	}
	add_filter( 'woocommerce_order_data_store_cpt_get_orders_query', 'wpslash_voucher_handle_courier_query_var', 10, 2 );
}


if (!function_exists('wpslash_voucher_get_order_weight')) {
	function wpslash_voucher_get_order_weight( $order_id) {
		$wpslash_voucher_weight = get_post_meta($order_id, 'wpslash_voucher_weight', true);
		if (!$wpslash_voucher_weight) { 
			$weight_calculation = get_option('wc_settings_tab_wpslash_global_voucher_weight_calculation', true);
			if ('auto' === $weight_calculation) {
				$wpslash_voucher_cart_weight = get_post_meta($order_id, 'wpslash_voucher_weight', true);
				if (!$wpslash_voucher_cart_weight) {

					$weight = 0;
					global $woocommerce;
					$_order = wc_get_order($order_id);
					if ( count( $_order->get_items() ) > 0 ) {
						foreach ( $_order->get_items() as $item ) {
							if ( $item['product_id'] > 0 ) {
								$_product = $_order->get_product_from_item( $item );
								if ( ! $_product->is_virtual() ) {
									$weight += $_product->get_weight() * $item['qty'];
								}
							}
						}
					}
					if ($weight > 0) {
						update_post_meta($order_id, 'wpslash_voucher_weight', $weight);
						$wpslash_voucher_weight = $weight;
					}


				}

			} else {

				$wpslash_voucher_weight = get_option('wc_settings_tab_wpslash_global_voucher_weight_fixed', true);
				if (!$wpslash_voucher_weight) {
					$wpslash_voucher_weight = 1;
				}






			}
					

		}
				return $wpslash_voucher_weight;
	}
}
