<?php

function wpslash_acs_voucher_acs_get_settings() {

	if (isset($_GET['section']) && 'acs' === $_GET['section']) {	
		$delivery_zones = WC_Shipping_Zones::get_zones();
		$delivery_instances = array();

		$acs_extra_services = wpslash_voucher_get_courier_extra_services_by_courier('acs');
		$acs_parcel_types = wpslash_voucher_get_courier_parcel_types_by_courier('acs');

		foreach ((array) $delivery_zones as $key => $the_zone ) {

			foreach ((array) $the_zone['shipping_methods'] as $shipping_method) {
				$delivery_instances[$shipping_method->instance_id] = $the_zone['zone_name'] . ' > ' . $shipping_method->title;
			}
			$countries = new WC_Countries();
			$countries = $countries->__get('countries'); 


		}
		$settings = array(
		'section_title' => array(
		'name' => __('ACS Courier', 'wpslash-acs-voucher'),
		'type' => 'title',
		'desc' => '',
		'id' => 'wc_settings_tab_wpslash_acs_voucher_section_title_acs',
		),
		'company_id' => array(
		'name' => __('Company ID', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Company ID provided by ACS Courier', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_company_id',
		),

		'customer_id' => array(
		'name' => __('Customer  ID', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Customer ID (Billing Code) provided by ACS Courier', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_customer_id',
		),

		'company_password' => array(
		'name' => __('Company Password', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Company Password provided by ACS Courier', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_company_password',
		),

		'username' => array(
		'name' => __('Username', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Username provided by ACS Courier', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_username',
		),
		'password' => array(
		'name' => __('Password', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Password provided by ACS Courier', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_password',
		),
		'api_key' => array(
		'name' => __('API Key', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Complete API Key if you are using the new system. Leave it empty if you are using the old', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_api_key',
		),
		'reference_key_1' => array(
		'name' => __('Reference Key 1', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Reference Key 1. You can use {order_number} to replaced with  your Order Number', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_reference_key_1',
		),
		'reference_key_2' => array(
		'name' => __('Reference Key 2', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Reference Key 2. You can use {order_number} to replaced with  your Order Number', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_reference_key_2',
		),

		'sender_name' => array(
		'name' => __('Sender Name', 'wpslash-acs-voucher'),
		'type' => 'text',
		'desc' => __('Sender Name to be Visible on Voucher', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_sender_name',
		),

		'recipient_charge' => array(
		'name' => __('Enable Recipient Charge Option', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can change the type of charge to the recipient', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_recipient_charge',
		),
		'extra_services_enabled' => !empty($acs_extra_services) ? array(
		'name' => esc_html__('Enable Extra Services from ACS', 'wpslash-acs-voucher'),
		'type' => 'multiselect',
		'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_countries_enabled',
		'desc' => esc_html__('Here you can select all the additional services that may used ', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_extra_services_enabled',
		'options' => $acs_extra_services,
		) : array(),

		'default_parcel_type' => !empty($acs_parcel_types) ? array(
		'name' => esc_html__('Default Parcel Type', 'wpslash-acs-voucher'),
		'type' => 'select',
		'class' => 'wc_settings_tab_wpslash_acs_voucher_default_parcel_type',
		'desc' => esc_html__('Known as Content Type ID and is required for parcels sent to Cyprus ', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_default_parcel_type',
		'options' => $acs_parcel_types,
		) : array(),


		'cyprus_economy' => array(
				'name' => __('Its Cyprus Economy', 'wpslash-acs-voucher'),
				'type' => 'checkbox',
				'desc' => __('Check if these credentials are for Cyprus and are for Cyprus Economy', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_voucher_cyprus_economy',
				),

		'rdo' => array(
		'name' => __('Enable RDO(Return Documents)', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can enable the Return Documents', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_rdo',
		),

		'rec' => array(
		'name' => __('Enable REC(Reception Delivery)', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can enable Reception Delivery', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_rec',
		),

		'acs_enabled' => array(
		'name' => __('Enable ACS Courier Web Services', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => '',
		'id' => 'wc_settings_tab_wpslash_acs_voucher_enabled',
		),
		'acs_email_enabled' => array(
		'name' => __('Enable Automatically Email Tracking Code', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => '',
		'id' => 'wc_settings_tab_wpslash_acs_voucher_email_enabled',
		),
		'acs_auto_tracing_enabled' => array(
		'name' => __('Enable Automatically Tracing the Orders', 'wpslash-acs-voucher'),
		'type' => 'checkbox',
		'desc' => __('By enabling this feature all orders from ACS Courier will automatically checked and the status of the order will be automatically updated to Delivery Completed or Delivery Denied. You can select the frequency will automatically check along with the date range ..', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_auto_tracing_enabled',
		),

		'acs_auto_tracing_frequency' => array(
		'name' => __('How often will check', 'wpslash-acs-voucher'),
		'type' => 'select',
		'desc' => __('You can select hourly , twice a day or daily....', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_auto_tracing_frequency',
		'options' => array(
		'hourly' => __('Every Hour', 'wpslash-acs-voucher'),
		'twicedaily' => __('Twice a Day', 'wpslash-acs-voucher'),
		'daily' => __('Every day', 'wpslash-acs-voucher'),
		),
		),
		'acs_email_subject' => array(
		'name' => __('Email Subject', 'wpslash-acs-voucher'),
		'type' => 'text',
		'default' => __('Shipping Information for {order_id}', 'wpslash-acs-voucher'),
		'desc' => __('Email Subject for Tracking Information. You can use {order_id} and it will be replaced with the Order ID', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_email_subject',
		),
		'acs_email_message' => array(
		'name' => __('Email Content', 'wpslash-acs-voucher'),
		'type' => 'textarea',
		'default' => __('Hi {first_name} {last_name} <br/> Your Order with ID {order_id} has been sent with ACS Courier.<br/> .Your tracking code is <strong> {tracking_code} <strong> and you can track your order by pressing <a href="https://www.acscourier.net/el/home">here</a>', 'wpslash-acs-voucher'),
		'desc' => __('Your email contents. You can use {order_id} ,  {tracking_code} , {first_name} , {last_name} and will be replaces with the appropriate values ', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_email_message',
		),
		'shipping_methods_enabled' => array(
		'name' => esc_html__('On Which Methods an ACS Voucher should be Generated', 'wpslash-acs-voucher'),
		'type' => 'multiselect',
		'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_methods_enabled',
		'desc' => esc_html__('Leave it empty for all shipping methods or select the  methods you want. This setting applies only to  auto-generated vouchers. You will still be able to generate a voucher manually even if the shipping method is not in the list.', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_shipping_methods_enabled',
		'options' => $delivery_instances,
		),

		'shipping_countries_enabled' => array(
		'name' => esc_html__('On Which Countries an ACS Voucher should be Generated', 'wpslash-acs-voucher'),
		'type' => 'multiselect',
		'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_countries_enabled',
		'desc' => esc_html__('Leave it empty for all countries or select the  methods you want. This setting applies only to  auto-generated vouchers. You will still be able to generate a voucher manually even if the Country is not in the list.', 'wpslash-acs-voucher'),
		'id' => 'wc_settings_tab_wpslash_acs_voucher_shipping_countries_enabled',
		'options' => $countries,
		),


		'section_end' => array(
		'type' => 'sectionend',
		'id' => 'wc_settings_tab_demo_section_end',
		),
		);
		return apply_filters('wc_settings_tab_wpslash_acs_voucher_settings', $settings);


	} //end if isset section acs//

}

function wpslash_acs_voucher_additional_instances_get_settings() {
	$acs_instances = get_option('wc_settings_tab_wpslash_voucher_global_acs_instances', true);
	$acs_extra_services = wpslash_voucher_get_courier_extra_services_by_courier('acs');
	$acs_parcel_types = wpslash_voucher_get_courier_parcel_types_by_courier('acs');

	if ($acs_instances > 1) {
	
		for ($i = 2; $i <= $acs_instances; $i++) {
			if (isset($_GET['section']) && 'acs_' . $i ===  $_GET['section']) {	
					$delivery_zones = WC_Shipping_Zones::get_zones();
				$delivery_instances = array();
				foreach ((array) $delivery_zones as $key => $the_zone ) {

					foreach ((array) $the_zone['shipping_methods'] as $shipping_method) {
						$delivery_instances[$shipping_method->instance_id] = $the_zone['zone_name'] . ' > ' . $shipping_method->title;
					}

				}
				$countries = new WC_Countries();
				$countries = $countries->__get('countries'); 

				$settings['section_title_' . $i] = array(
				'name' => __('ACS Courier', 'wpslash-acs-voucher') . ' ' . $i,
				'type' => 'title',
				'desc' => '',
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_section_title_acs',
				);
				$settings['company_id_' . $i] = array(
				'name' => __('Company ID', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Company ID provided by ACS Courier', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_company_id',
				);

				$settings['customer_id_' . $i] = array(
				'name' => __('Customer  ID', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Customer ID (Billing Code) provided by ACS Courier', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_customer_id',
				);

				$settings['company_password_' . $i] = array(
				'name' => __('Company Password', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Company Password provided by ACS Courier', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_company_password',
				);

				$settings['username_' . $i] = array(
				'name' => __('Username', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Username provided by ACS Courier', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_username',
				);
				$settings['password_' . $i] = array(
				'name' => __('Password', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Password provided by ACS Courier', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_password',
				);
				$settings['api_key_' . $i] = array(
				'name' => __('API Key', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Complete API Key if you are using the new system. Leave it empty if you are using the old', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_api_key',
				);


				$settings['reference_key_1_' . $i] =  array(
				'name' => __('Reference Key 1', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Reference Key 1. You can use {order_number} to replaced with  your Order Number', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_reference_key_1',
				);
				$settings['reference_key_2_' . $i] =  array(
				'name' => __('Reference Key 2', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Reference Key 2. You can use {order_number} to replaced with  your Order Number', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_reference_key_2',
				);

				$settings['sender_name_' . $i] = array(
				'name' => __('Sender Name', 'wpslash-acs-voucher'),
				'type' => 'text',
				'desc' => __('Sender Name to be Visible on Voucher', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_sender_name',
				);

				$settings['recipient_charge_' . $i] = array(
				'name' => __('Enable Recipient Charge Option', 'wpslash-acs-voucher'),
				'type' => 'checkbox',
				'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can change the type of charge to the recipient', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_recipient_charge',
				);

				if (!empty($acs_extra_services)) {
						$settings['extra_services_enabled_' . $i] = array(
						'name' => esc_html__('Enable Extra Services from ACS', 'wpslash-acs-voucher'),
						'type' => 'multiselect',
						'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_countries_enabled',
						'desc' => esc_html__('Here you can select all the additional services that may used ', 'wpslash-acs-voucher'),
						'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_extra_services_enabled',
						'options' => $acs_extra_services
						);
				}
				if (!empty($acs_parcel_types)) {
						$settings['default_parcel_type_' . $i] = array(
						'name' => esc_html__('Default Parcel Type', 'wpslash-acs-voucher'),
						'type' => 'select',
						'class' => 'wc_settings_tab_wpslash_acs_voucher_default_parcel_type',
						'desc' => esc_html__('Known as Content Type ID and is required for parcels sent to Cyprus ', 'wpslash-acs-voucher'),
						'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_default_parcel_type',
						'options' => $acs_parcel_types
						);
				}

					$settings['cyprus_economy_' . $i] = array(
				'name' => __('Check it IF IS Cyprus Economy', 'wpslash-acs-voucher'),
				'type' => 'checkbox',
				'desc' => __('Check if these credentials are for Cyprus and are for Cyprus Economy', 'wpslash-acs-voucher'),
				'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_cyprus_economy',
					);
			

					$settings['rdo_' . $i] = array(
					'name' => __('Enable RDO(Return Documents)', 'wpslash-acs-voucher'),
					'type' => 'checkbox',
					'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can enable the Return Documents', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_rdo',
					);

					$settings['rec_' . $i] = array(
					'name' => __('Enable REC(Reception Delivery)', 'wpslash-acs-voucher'),
					'type' => 'checkbox',
					'desc' => __('This will add a new option on column Voucher Settings under WooCommerce Orders where you can enable Reception Delivery', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_rec',
					);

					$settings['acs_enabled_' . $i] = array(
					'name' => __('Enable ACS Courier Web Services', 'wpslash-acs-voucher'),
					'type' => 'checkbox',
					'desc' => '',
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_enabled',
					);
					$settings['acs_email_enabled_' . $i] = array(
					'name' => __('Enable Automatically Email Tracking Code', 'wpslash-acs-voucher'),
					'type' => 'checkbox',
					'desc' => '',
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_email_enabled_',
					);
					$settings['acs_email_subject_' . $i] = array(
					'name' => __('Email Subject', 'wpslash-acs-voucher'),
					'type' => 'text',
					'default' => __('Shipping Information for {order_id}', 'wpslash-acs-voucher'),
					'desc' => __('Email Subject for Tracking Information. You can use {order_id} and it will be replaced with the Order ID', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_email_subject',
					);
					$settings['acs_email_message_' . $i] = array(
					'name' => __('Email Content', 'wpslash-acs-voucher'),
					'type' => 'textarea',
					'default' => __('Hi {first_name} {last_name} <br/> Your Order with ID {order_id} has been sent with ACS Courier.<br/> .Your tracking code is <strong> {tracking_code} <strong> and you can track your order by pressing <a href="https://www.acscourier.net/el/home">here</a>', 'wpslash-acs-voucher'),
					'desc' => __('Your email contents. You can use {order_id} ,  {tracking_code} , {first_name} , {last_name} and will be replaces with the appropriate values ', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_email_message',
					);
					$settings['shipping_methods_enabled_' . $i] = array(
					'name' => esc_html__('On Which Methods an ACS Voucher should be Generated', 'wpslash-acs-voucher'),
					'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_methods_enabled',

					'type' => 'multiselect',
					'desc' => esc_html__('Leave it empty for all shipping methods or select the  methods you want. This setting applies only to  auto-generated vouchers. You will still be able to generate a voucher manually even if the shipping method is not in the list.', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_shipping_methods_enabled',
					'options' => $delivery_instances,
					);

					$settings['shipping_countries_enabled'] = array(
					'name' => esc_html__('On Which Countries an ACS Voucher should be Generated', 'wpslash-acs-voucher'),
					'type' => 'multiselect',
					'class' => 'wc_settings_tab_wpslash_acs_voucher_shipping_countries_enabled',
					'desc' => esc_html__('Leave it empty for all countries or select the  methods you want. This setting applies only to  auto-generated vouchers. You will still be able to generate a voucher manually even if the Country is not in the list.', 'wpslash-acs-voucher'),
					'id' => 'wc_settings_tab_wpslash_acs_' . $i . '_voucher_shipping_countries_enabled',
					'options' => $countries,
					);

					$settings['section_end_new'] = array(
					'type' => 'sectionend',
					'id' => 'wc_settings_tab_demo_section_end_' . $i,
					);

					return apply_filters('wc_settings_tab_wpslash_acs_voucher_additional_instance_settings', $settings);

			}//end if isset

		}

	}
}



add_action('wpslash_voucher_save_settings', 'save_wpslash_acs_voucher_settings');
function save_wpslash_acs_voucher_settings() {
		woocommerce_update_options(wpslash_acs_voucher_acs_get_settings());
		woocommerce_update_options(wpslash_acs_voucher_additional_instances_get_settings());


}

add_action('wpslash_voucher_render_settings', 'render_wpslash_acs_voucher_settings');
function render_wpslash_acs_voucher_settings() {
		woocommerce_admin_fields(wpslash_acs_voucher_acs_get_settings());
		woocommerce_admin_fields(wpslash_acs_voucher_additional_instances_get_settings());


}


