<?php
/**
* The plugin bootstrap file
*
* This file is read by WordPress to generate the plugin information in the plugin
* admin area. This file also includes all of the dependencies used by the plugin,
* registers the activation and deactivation functions, and defines a function
* that starts the plugin.
*
* @link              https://www.wpslash.com
* @since             2.4.7
* @package           ACS_Courier_Voucher
*
* @wordpress-plugin
* Plugin Name:       ACS Courier Voucher for WooCommerce
* Plugin URI:        https://www.wpslash.com
* Description:       WooCommerce connector for ACS Courier for Automatic Voucher Creation.
* Version:           2.4.7
* Author:            WPSlash
* Author URI:        https://www.wpslash.com/plugin/wpslash-acs-voucher-for-woocommerce/
* License:           GPL-2.0+
* License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
* Text Domain:       wpslash-acs-voucher
* Domain Path:       /languages
* WC requires at least: 3.4
* WC tested up to: 5.0.0
* Woo: 4887842:f2731d898e63beb78f362dc8827c6e80
*
* Copyright: © 2009-2019 WooCommerce.
* License: GNU General Public License v3.0
* License URI: http://www.gnu.org/licenses/gpl-3.0.html
*/


// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
define( 'WPSLASH_ACS_VOUCHER_PLUGIN_DIR_URL', plugin_dir_url( __file__ ));  
define( 'WPSLASH_ACS_VOUCHER_PLUGIN_DIR', dirname(__FILE__) . '' );  
define('WPSLASH_ACS_VOUCHER_PLUGIN_FILE', __FILE__);
define('WPSLASH_ACS_VOUCHER_PLUGIN_VERSION', '2.4.7');

add_action('plugins_loaded', 'wpslash_acs_voucher_load_textdomain');
function wpslash_acs_voucher_load_textdomain() {
	load_plugin_textdomain( 'wpslash-acs-voucher', false, dirname( plugin_basename(__FILE__) ) . '/languages/' );
}


//check if WooCommerce is activated
if ( 
  in_array( 
	'woocommerce/woocommerce.php', 
	apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) 
	) 
  ) {
	
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.functions.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/activation.hook.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.settings.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/settings.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/admin.page.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.shoporder.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.order.statuses.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.ajax.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/ajax.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/autotrace.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/global.autocreate.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/autocreate.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/email.hooks.php';
	require_once WPSLASH_ACS_VOUCHER_PLUGIN_DIR . '/inc/courier.hooks.php';




}//end check if WooCommerce is activated




